<%@ page language="java" contentType="text/javascript" %>

<%@ include file="/common/taglibs.jsp" %>

<fmt:setBundle basename="ncw.nl.lwsel.uiresources" var="langset" scope="request"/>

/******************************************************************************************
 *
 */
function drawArrow(column) {


 var oldDirection = document.forms[ "lwselform" ].elements[ "sortcolumndir" ].value;
 var oldSortColumn = document.forms[ "lwselform" ].elements[ "sortcolumnfield" ].value;

 if(oldDirection != null && oldSortColumn != null && oldSortColumn == column) {

   	if(oldDirection == "asc") {
	
		img = "<img src='images/arrow_up.png' align='top' width='6' alt='<fmt:message bundle="${langset}" key="view.table.sort.ascending"/>'/>";

   	}else if(oldDirection == "desc") {
	
		img = "<img src='images/arrow_down.png' align='top' width='6' alt='<fmt:message bundle="${langset}" key="view.table.sort.descending"/>'/>";
  	}
  
  document.write( img );
 }

}

document.onkeydown = handleKeyPress;

<c:if test="${param.isPortlet == 'true'}">
function processEvent(event)
{
	if (event.name.indexOf('portletResize') != -1)
	{
		ResizeController.resize();	
	}
}
</c:if>

ResizeController = new function()
{
	var retryCount = 0;
	this.resize = function()
	{		
		var eventTableContainer = document.getElementById('eventTableContainerDiv');
		var eventToolTable = document.getElementById('eventToolTable');

		var alertHeaderContainer = document.getElementById('alertsTableHeaderContainerDiv');
		var alertsTable=document.getElementById('alertsTableDiv');

		var eventSummaryTable = document.getElementById('eventSummaryTable');

		var availableHeight = document.documentElement.clientHeight - 2; // remove the border pixel
		var availableWidth = document.documentElement.clientWidth - 2; // remove the border pixel
		
		// For special cases below.
		var ieScrollBarWidth = 20;

		<%-- Need this because documentElement.clientWidth/Height don't return correct values when
		running as portlet in IE --%>
		<c:if test="${param.isPortlet == 'true'}">
		
			var nVer = navigator.appVersion;
			var nAgt = navigator.userAgent;
			if ( (verOffset=nAgt.indexOf("MSIE")) != -1 )
			{
				var iscPortletNameSpaceString = frameElement.getAttribute('iscportletnamespace');
				var ISCWorkArea = window.parent;
				var portletSize = ISCWorkArea.iscPortlet.getPortletSize( iscPortletNameSpaceString );
				availableHeight = portletSize.available.h - ieScrollBarWidth;
				availableWidth = portletSize.available.w - ieScrollBarWidth;
			}
		</c:if>

		<%-- ALM00107352: Workaround for TBSM when the LEL table loses its vertical scrollbar due to
		lack of vertical space. --%>
		var headerFooterHeight = 126; // LEL header/toolbar + footer (summary & status bars)
		var minEventTableHeight = 58; // event table header row + 2 rows + some borders
		var minEventTableContainerHeight = minEventTableHeight + headerFooterHeight;
		var workingHeight;

		if (availableHeight < minEventTableContainerHeight) {
			<%-- Height too small, so enforce a minimum LEL height to prevent event table vertical
			scrollbar from *dis*appearing. This forces the LEL's IFrame to use its scrollbar. --%>
			eventTableContainer.style.height = minEventTableContainerHeight + "px";
			workingHeight = minEventTableContainerHeight;

			<%--
			Both FF and IE7 don't resize the LEL width properly when the IFrame scrollbar
			appears, such that it also brings up a horizontal scrollbar. This occurs when the LEL
			reloads, but not when first resized. Tradeoff is we get a slightly narrower LEL on
			first resize. Reusing ieScrollBarWidth even for FF.
			--%>
			availableWidth -= ieScrollBarWidth;
		}
		else {
			eventTableContainer.style.height = availableHeight + "px";
			workingHeight = availableHeight;
		}
		<%-- End of main change for ALM00107352 --%>

		eventTableContainer.style.width = (availableWidth) +"px";

		eventToolTable.style.width = availableWidth+"px";

		// remove the height of header/tool bar and summary and status bar
		alertsTable.style.height = (workingHeight - headerFooterHeight) + "px";
		alertsTable.style.width = (availableWidth)+"px";
		alertHeaderContainer.style.width = (availableWidth)+"px";

		eventSummaryTable.style.width = (availableWidth )+"px";
		
		// enable alerts table 
		var alertsDataContainer = document.getElementById('alertsDataContainerDiv');
		alertsDataContainer.style.visibility = "visible";
		alertsDataContainer.style.display = "block";
		alertsTable.focus();
		
		setAlertTableHeaderScrolling(alertsTable); //to fix a rendering issue in IE6, doesn't set scrolling of header correctly
		eventTableParent = eventTableContainer.parentNode;
		eventTableParent.replaceChild(eventTableContainer,eventTableContainer);
	}


}

function initAlertTableScrollingPosition()
{
	var alertsTable=document.getElementById('alertsTableDiv');

	var alertsTableDivScrollLeft = parseInt("<c:out value="${param.alertsTableDivScrollLeft}" />");
	var alertsTableDivScrollTop = parseInt("<c:out value="${param.alertsTableDivScrollTop}" />");

	if (!alertsTableDivScrollLeft)
	{
		alertsTableDivScrollLeft = 0;
	}
	if (!alertsTableDivScrollTop)
	{
		alertsTableDivScrollTop = 0;
	}		
	
	document.forms[ "lwselform" ].elements[ "alertsTableDivScrollLeft" ].value=alertsTableDivScrollLeft;
	document.forms[ "lwselform" ].elements[ "alertsTableDivScrollTop" ].value=alertsTableDivScrollTop;

	alertsTable.scrollLeft = alertsTableDivScrollLeft;
	alertsTable.scrollTop = alertsTableDivScrollTop;
}


function setAlertTableHeaderScrolling(theElement)
{
	var headerElement = document.getElementById('alertTableHeader');
	if (!headerElement.style.left)
	{
		headerElement.style.left = "0px";
	}
	headerElement.style.left = -theElement.scrollLeft + "px";

	document.forms[ "lwselform" ].elements[ "alertsTableDivScrollLeft" ].value=theElement.scrollLeft;
	document.forms[ "lwselform" ].elements[ "alertsTableDivScrollTop" ].value=theElement.scrollTop;

}