<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ page import="javax.portlet.RenderRequest" %>
<%@ page import="javax.portlet.RenderResponse" %>

<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %> 
<%@ taglib uri="http://java.sun.com/portlet" prefix="portlet" %>
<%@ taglib uri="http://ibm.com/isc/portlet" prefix="iscPortletAPI" %>

<fmt:setBundle var="commonBundle" basename="com.ibm.tivoli.nam.portal.nl.portlet.IFrame" scope="request"/>

<portlet:defineObjects/>

<c:choose>
	<c:when test="${!empty iFrameBean.url}">

		<c:set var="parameters" value="${iFrameBean.parameterMap}" />
		<c:url var="displayURL" value="${iFrameBean.url}" context="/" scope="request">
			<c:forEach var="nextParam" items="${parameters}" varStatus="count">
				<c:param name="${nextParam.key}" value="${nextParam.value}" />
			</c:forEach>
		</c:url>
	</c:when>
	<c:otherwise>
		<c:url var="displayURL" value="/portletpages/iFrameError.jsp" scope="request" > 
			<c:param name="noUrlDetailKey" value="${noUrlDetailKey}" />
		</c:url> 
	</c:otherwise>
</c:choose>

<%
	String encodedURL = (String) request.getAttribute("displayURL");
	if (encodedURL.startsWith("//"))
	{
		encodedURL = encodedURL.substring(1);
	}
%>
	
<c:set var="iFrameName">
	<c:out value="${iFrameBean.iFrameName}" />
</c:set>

<script type="text/javascript">	 
	/**
	 * This function receives the event triggered by other portlets, if it's entitled to receive.
	 * It then delegates the event to the processEvent(...) method of the embedded iframe
	 * The processEvent(event) method must be implemented by the content embedded in the iframe
	 * in order to receive that event.
	 *
	 * @event TIP Actions Event Object
	 */
  	function <iscPortletAPI:processEventHandler/>(event) 
  	{  	
  		if(event != null)
		{
			
			if (event.name.indexOf('portletResize') != -1)
			{
				// ResizeController function is only include if iframe is configured to use 
				// the customizer for resizing, edit mode - checkbox Use Customizer = selected
				<c:if test="${iFrameBean.useCustomizer == 'true'}" >
					<portlet:namespace/>_ResizeController.resize();
				</c:if>
			}
			
			// Call processEvent() method of the receiving portlet.
			<portlet:namespace/>_IFramePortletElement.processEvent(event);
		}
	}

	
	/**
	 * This controlls the resizing of the IFrame either on first time loading
	 * or when a resize event is received. Resize event will only be received if the portlet 
	 * is configured to subscribe to ISCs http://ibm.com/isclite:portletResize event.
	 * To subscribe to this event, the following setup needs to be done in the applications
	 * ibm-portal-event.xml for the appropriate IFramePortlet:
	 *
	 *	<events:portlet-definition-ref portletDefinitionRef="<YOUR PORTLET DEF>">
	 *
	 *		<events:supported-subscribed-event>
	 *			<events:name xmlns:x="http://ibm.com/isclite">x:portletResize</events:name>
	 *		</events:supported-subscribed-event>
	 *
	 *	</events:portlet-definition-ref>
	 *
	 *	<YOUR PORTLET DEF> - refers to the value of attribute'uniqueName'
	 * in the 'portlet-definition' element in the applications ibm-portal-topology.xml
	 */
	<portlet:namespace/>_ResizeController = new function()
	{
		var retryCount = 0;
    		this.resize = function()
		{
			retryCount++;
			// check to see if this is looping too much
			if ( retryCount > 10 )
			{
            			// give up after 10 failed tries
				retryCount = 0;
				return;
			}
			var resizeElement = document.getElementById('<c:out value="${iFrameName}" />');
			var portletSize;
			

			// Need to first check whether we are using the isolate portlet mechanism or not.
			if( isISCIFrame() )
			{
				// Need to get a handle on the ISCWork frame. 
				var ISCWorkArea = <portlet:namespace/>_IFramePortletElement.window.parent.parent;
				portletSize = ISCWorkArea.iscPortlet.getPortletSize( '<iscPortletAPI:namespace/>' );
			}
			else
			{
				portletSize = iscPortlet.getPortletSize( '<iscPortletAPI:namespace/>' );
			}

			if ( ! portletSize || !portletSize.available.h)
			{
				// try again shortly
				setTimeout( '<portlet:namespace/>_ResizeController.resize()', 50 );
            			return;
        		}
        		
			retryCount = 0; // reset counter
			newPortletSize = portletSize.available.h;
			resizeElement.style.height = newPortletSize + 'px';
			
			if ( isISCIFrame() ) 
			{
				var iscIFrameID = getISCPortletNamespaceId();
				<portlet:namespace/>_IFramePortletElement.parent.parent.document.getElementById(iscIFrameID).style.height = newPortletSize + 'px';
			}
		}
	}
	
	var <portlet:namespace/>_IFramePortletElement = null;
	
	function <portlet:namespace/>_performResize()
	{
	
		var <portlet:namespace/>_IFramePortletElementName = "<c:out value="${iFrameName}" />";
		
	
		for (var i = 0; i < window.frames.length; i++)
		{
			if ( window.frames[i].name == <portlet:namespace/>_IFramePortletElementName )
			{
				<portlet:namespace/>_IFramePortletElement = window.frames[i];
				break;
			}
		}
		
		
		// Need to first check whether we are using the isolate portlet mechanism or not.
		if( isISCIFrame() )
		{
			// Need to determine the DOM id for the isolated portlets iframe element.
			var <portlet:namespace/>_isolatePortletFrameId = '<c:out value="${iFrameName}" />';			
			<portlet:namespace/>_isolatePortletFrameId = getISCPortletNamespaceId();
	
			// Need to get a handle on the ISCWork frame. 
			var <portlet:namespace/>_ISCWorkArea = <portlet:namespace/>_IFramePortletElement.window.parent.parent;
	
			// Remove the margin from the body of the isolate portlet iframe.
			document.getElementById('<c:out value="${iFrameName}" />').parentNode.parentNode.style.margin = "0px";
	
			// Remove the padding from the table that includes the isolate portlets iframe.
			<portlet:namespace/>_ISCWorkArea.document.getElementById(<portlet:namespace/>_isolatePortletFrameId).parentNode.parentNode.parentNode.parentNode.style.padding = "0px";
	
			// Remove the padding from the td containing the table which displays the isolate portlets iframe.
			<portlet:namespace/>_ISCWorkArea.document.getElementById(<portlet:namespace/>_isolatePortletFrameId).parentNode.parentNode.parentNode.parentNode.parentNode.style.padding = "0px";
		}
		else
		{
			document.getElementById('<c:out value="${iFrameName}" />').parentNode.parentNode.parentNode.parentNode.style.padding = "0px";
			document.getElementById('<c:out value="${iFrameName}" />').parentNode.parentNode.parentNode.parentNode.parentNode.style.padding = "0px";
		}
	
		<c:if test="${iFrameBean.useCustomizer == 'true'}" >
			<portlet:namespace/>_ResizeController.resize();
		</c:if>
	}
	
	function getISCPortletNamespaceId()
	{
		var iscIFrameID = '<iscPortletAPI:namespace/>';
		iscIFrameID = iscIFrameID.substring(5, iscIFrameID.lastIndexOf('pns')-1);
		if (iscIFrameID.charAt(0) == 'm')
		{
			iscIFrameID = iscIFrameID.substring(1);
			iscIFrameID = "-" + iscIFrameID;
		}
		
		iscIFrameID = "_" + iscIFrameID + "_iframe";
		return iscIFrameID;
	}
	
	function isISCIFrame()
	{
		if (<portlet:namespace/>_IFramePortletElement.parent)
		{	
			var <portlet:namespace/>_isoName = <portlet:namespace/>_IFramePortletElement.parent.name;
			return ( <portlet:namespace/>_isoName != null && <portlet:namespace/>_isoName == "isc_iframe" );
		}
	}
</script>

<iframe
	id="<c:out value="${iFrameName}" />"
	name="<c:out value="${iFrameName}" />"
	src="<%=encodedURL%>"
	height="<c:out value="${iFrameBean.height}" />"
	width="100%"
	scrolling="auto"
	marginheight="0"
	marginwidth="0"
	frameborder="0"
	vspace="0"
	hspace="0"
	style="overflow:visible; display:block;"
	allowtransparency="true"
	iscportletnamespace="<iscPortletAPI:namespace/>"
	onload="<portlet:namespace/>_performResize();"
>
<fmt:message bundle="${commonBundle}" key="portlet.view.message.noIFrame"/>
</iframe>

<script type="text/javascript">	 
<portlet:namespace/>_performResize();
</script>