//global constants. Used in jsps also
var STRING_COLUMN_DATATYPE = 'string';
var INT_COLUMN_DATATYPE = 'int';
var STRINGCOMBO_COLUMN_DATATYPE = 'stringCombo';

var timer = null;

/*
* On form load we are restoring the sorting and filtering if user had been applied such
*
*/
function loadTablesState(portletFragment){
	
	var tables = null;
	if(portletFragment == null || typeof portletFragment == 'undefined'){
		var page = getCurrentPage();
		var tables = page.getTables();
	}else{
		tables = portletFragment.getElementsByTagName("TABLE");
	}
    
	for(i=0; i < tables.length; i++){
    	var tableDataObject = new AdminTable(tables[i]);
		if(tableDataObject.isValid()){
			
			//only ISC Admin Tables tables participate in saving/loading state
			dojo.xhrPost({
				url: "/ibm/console/kts.do?requestType=load&tableId=" + tableDataObject.id,
				handleAs: 'json-comment-filtered',
				load: function(state){ 
						if(state != null && document.getElementById(state.tableId) != null){
							new AdminTable(document.getElementById(state.tableId)).loadState(state); 
						}},
				error: function(error) { console.debug("LoadTableState Error Handler: " + error);}
			});
		
		}
    }
	
}

/*
 * On form post we are searching for AdminTables and perist their state (filtering/sorting) in the server
 *
 */
function saveTablesState(evt){
	
	var tables = null;
	//console.log(evt);
	if(evt == null || typeof evt == 'undefined'){
		//save state for all tables in the current page
		var page = getCurrentPage();
		tables = page.getTables();
	}else{
		//the source could be a page or a portlet fragment
		tables = evt.source.getElementsByTagName("TABLE");
	}
    
	for(i=0; i < tables.length; i++){
        var tableDataObject = new AdminTable(tables[i]);
	
		if(tableDataObject.isValid()){
			
			var state = tableDataObject.getState();
			//expanded nodes are not updated in the state till saving state, because it is too time consuming
			state.expandedNodes = tableDataObject.getExpandedNodes();
			
			var serializedState = dojo.toJson(tableDataObject.getState());
			dojo.xhrPost({
				url: "/ibm/console/kts.do?requestType=save&tableId=" + tableDataObject.id + "&tableState=" + serializedState,
				load: function(){/*Do nothing. Let the server side logic to persist the table state*/},
				error: function(error) { console.debug("SaveTablesState Error Handler: " + error); }
			});
		
        }
    }
	
}

//get the Page object 
function getCurrentPage(){
	// SM_IF2 IFrames now specified on a portlet level rather than universally.
	if( ISC_CONSOLE_SM_INIFRAME ) {
		// If inside an iframe, fake a Page object
		page = new Object();

		page.getTables = function(){
			return( getElementTables( document.body ) );
		};

		return( page );
	}
	else {
		if (IscPages.currentPageId == null ) {
			IscPages.init();
		}
		pageId = IscPages.currentPageId;
		page = document.getElementById(pageId);

		return new Page(page);
	}
}

function getElementTables( element ) {
	var retVal = new Array();
	if( element.nodeName.toLowerCase() == "table" ) {
		retVal.push( element );
	}
	if( element.hasChildNodes ) {
		for( var i = 0; i < element.childNodes.length; i++ ) {
			retVal = retVal.concat( getElementTables( element.childNodes[i] ) );
		}
	}
	return( retVal );
}


/**
 * JSON object that capsulates sort and filter criterion and inputs. It is serialized to string and serialized in a hidden input for given table and peristed as a string into the server memory
 *
 */
function AdminTableState(tableId){
	
	this.tableId = tableId;	
	this.filterString = "";
	this.filterChecksToggled=false;
	this.filteringColumns = "";
	this.currentSortedColumnIndex = -1;
	this.lastSortedColumnIndex = -1;
	this.lastSortedColumnType = "";
	this.expandedNodes = "";
	this.sortOrderImagePath = "";
	this.isNull = false;
	
}	
	
function AdminTable(table){

	this.table = table;
	this.id = table.id;
	//initialized in the constructor below
	this.state = null;
	
	//constants
	AdminTable.prototype.FLAT_TABLE_TYPE = 'ISC_FLAT_TABLE';
	AdminTable.prototype.HIERARCHICAL_TABLE_TYPE = 'ISC_HIERARCHICAL_TABLE';
	AdminTable.prototype.FILTER_DROPDOWN_ID = "popupMenu" + this.id;
	AdminTable.prototype.FILTER_ALL_OPTION_ID = "selectedColumnsAllOptionId" + this.id;
	AdminTable.prototype.STATE_SERIALIZED_HIDDEN_INPUT = "serializedState" + this.id;
	AdminTable.prototype.SELECTED_COLUMNS_DELIMITER = ",";
	
	AdminTable.prototype.defSortImagePath = '/ibm/console/images/isclite/content/i_sort01.gif';
	AdminTable.prototype.ascSortImagePath = '/ibm/console/images/isclite/content/i_sort03.gif';  
	AdminTable.prototype.descSortImagePath = '/ibm/console/images/isclite/content/i_sort02.gif'; 
	AdminTable.prototype.columnSelectedForFilteringImagePath = '/ibm/console/images/isclite/content/tick.gif';
	AdminTable.prototype.columnNotSelectedForFilteringImagePath = '/ibm/console/images/isclite/content/emptyTick.gif';

	 
	//keeping state
	AdminTable.prototype.setState = setState;
	AdminTable.prototype.getState = getState;
	AdminTable.prototype.loadState = loadState;
	AdminTable.prototype.serializeState = serializeState;
	AdminTable.prototype.isValid = isValid;
	
	//table type
	AdminTable.prototype.getType = getType;
	AdminTable.prototype.isFlat = isFlat;
	AdminTable.prototype.isHierarchical = isHierarchical;
	
	//filtering
	AdminTable.prototype.filter = filter;
	AdminTable.prototype.getFilterableTableColumnNames = getFilterableTableColumnNames;
	AdminTable.prototype.getSelectedColumnIndexes = getSelectedColumnIndexes;
	AdminTable.prototype.exploreNodeWithKey = exploreNodeWithKey;
	AdminTable.prototype.toggleFilterableColumn = toggleFilterableColumn;
	AdminTable.prototype.toggleFilterableColumns = toggleFilterableColumns;
	AdminTable.prototype.tableRowFiltered = tableRowFiltered;
	AdminTable.prototype.createFilterDropdownMenu = createFilterDropdownMenu;
	AdminTable.prototype.getColumnNameIndex = getColumnNameIndex;
	AdminTable.prototype.isTickUncheckAllowed = isTickUncheckAllowed;

	//sorting
	AdminTable.prototype.sort = sort;
	AdminTable.prototype.performDefaultSort = performDefaultSort;
	AdminTable.prototype.performAscSort = performAscSort;
	AdminTable.prototype.performDescSort = performDescSort;
	AdminTable.prototype.reverseRows = reverseRows;
	AdminTable.prototype.getTableRowsAsArray = getTableRowsAsArray;
	AdminTable.prototype.appendTableRows = appendTableRows;
	AdminTable.prototype.appendFillerRows = appendFillerRows;	
	AdminTable.prototype.getSortComparator = getSortComparator;
	AdminTable.prototype.updateSortImgAndCaptions = updateSortImgAndCaptions;
	AdminTable.prototype.setSortImgAndCaptions = setSortImgAndCaptions;
	AdminTable.prototype.stringComparator = stringComparator;
	AdminTable.prototype.intComparator = intComparator;
	AdminTable.prototype.stringComboComparator = stringComboComparator;
	
	//expanded nodes
	AdminTable.prototype.getExpandedNodes = getExpandedNodes;

	
	//CONSTRUCTOR
	if(!this.isValid()){
		return;
	}
	this.type = this.getType();
	if(/*this.table.getAttribute("state") == null)*/document.getElementById(this.STATE_SERIALIZED_HIDDEN_INPUT) == null){
		//this.setState(new AdminTableState(this.id));
		var hiddenTableState = document.createElement("input");
		hiddenTableState.setAttribute("type", "hidden");
		hiddenTableState.setAttribute("id", this.STATE_SERIALIZED_HIDDEN_INPUT);
		hiddenTableState.setAttribute("name", this.id);			
		var state = new AdminTableState(this.id);
		hiddenTableState.setAttribute("value", dojo.toJson(state));
		this.table.parentNode.appendChild(hiddenTableState);
		this.setState(state);
	}else{
		//var stateObj = dojo.fromJson(this.table.getAttribute("state"));
		//this.setState(stateObj);
		var hiddenTableState = document.getElementById(this.STATE_SERIALIZED_HIDDEN_INPUT).value;
		var state = dojo.fromJson(hiddenTableState);
		this.setState(state);
	}
	
	
	/*=====================FUNCTION IMPLEMENTATIONS (inner functions for AdminTable in order to reduce global space pollution,)  =====================*/
	
	function isValid(){
		if(!(this.isHierarchical() || this.isFlat())){
			return false;
		}
		
		if(!this.table){
			return false;
		}
		
		return true;
	}

	function setState(state){
		//this.table.setAttribute("state", dojo.toJson(state));
		this.state = state;
	}
	
	function getState(){
		return this.state;
	}
	
	//serialize state in the current document in order to be readed from there on every AdminTable construction
	function serializeState(){
		document.getElementById(this.STATE_SERIALIZED_HIDDEN_INPUT).value = dojo.toJson(this.state);
	}
	
	//for now we have Flat and Hierarchical tables. They are distinct by the name attribute of the table
	function getType(){
		if(this.type == null){
			var tableName = this.table.getAttribute("name");
			return tableName;
		}else{
			return this.type;
		}
	}
	
	//actual restore of filtering and sorting of a table. This is the callback function of loading table state Ajax request
	function loadState(state){
		this.createFilterDropdownMenu();
		if(state.isNull){
			this.performDefaultSort();
			if(this.isHierarchical()){
				iscAlternateTableRows(this.id);
			}
		}else{
			this.setState(state);
			this.toggleFilterableColumns(state.filteringColumns);
			
			//filtering
			if(state.filterString != ''){
				var filterTextbox = document.getElementById('qf' + this.id);
				filterTextbox.value = state.filterString;
				filterTextbox.className = 'qf-textfield'; 
				this.filter(state.filterString);
			}
				
			if(state.lastSortedColumnIndex == -1){
				this.performDefaultSort();
			}else if(state.sortOrderImagePath.indexOf(this.descSortImagePath) != -1){
				this.performDescSort(state.lastSortedColumnIndex, state.lastSortedColumnType);
			}else if(state.sortOrderImagePath.indexOf(this.ascSortImagePath) != -1){
				this.performAscSort(state.lastSortedColumnIndex, state.lastSortedColumnType);
			}
			
			if(this.isHierarchical(state.lastSortedColumnIndex, state.lastSortedColumnType)){
				var expandedNodes = state.expandedNodes;
				var expandedList = expandedNodes.split(',');
				iscExpandTreeNodes(this.id, 'RootNode', expandedList);
			}
		}
		this.appendFillerRows();
	}
	
	function isFlat(){
		return this.getType() == this.FLAT_TABLE_TYPE;
	}
	
	function isHierarchical(){
		return this.getType() == this.HIERARCHICAL_TABLE_TYPE;
	}

	//this method sorted the given column descending
	function performDescSort(selectedColumnIndex, columnDataType){
		this.performAscSort(selectedColumnIndex, columnDataType);
		this.reverseRows();
		this.setSortImgAndCaptions(selectedColumnIndex, this.descSortImagePath, getDescendingSortTitle());
		
	}
	
	//this method sorted the given column ascending
	function performAscSort(selectedColumnIndex, columnDataType){
		
		this.state.currentSortedColumnIndex = selectedColumnIndex;
		this.serializeState();	
		var tableRowsArray = this.getTableRowsAsArray();
		var comparatorFunc = this.getSortComparator(columnDataType);
		
		if(this.isHierarchical()){
			for (var key in tableRowsArray) {
				sortColumn(tableRowsArray[key], this, selectedColumnIndex, comparatorFunc, columnDataType);
			}
			var sortedHierarchicalRows = concatHierarchicalRows(tableRowsArray, 'RootNode');
			//sortedHierarchicalRows are already sorted - populate in the table
			this.appendTableRows(sortedHierarchicalRows);
			
		}else if(this.isFlat()){
			sortColumn(tableRowsArray, this, selectedColumnIndex, comparatorFunc, columnDataType);
			//tableRowsArray are already sorted - populate in the table
			this.appendTableRows(tableRowsArray);
		}
		
		this.setSortImgAndCaptions(selectedColumnIndex, this.ascSortImagePath, getAscendingSortTitle());
		
	}
	
	//this method is used on every 
	function sort(selectedColumnIndex, columnDataType){
		startTime = new Date().getTime();
		
		if(selectedColumnIndex == -1){
			//just in case
			this.performDefaultSort();
			return;
		}
		
		if( selectedColumnIndex == this.state.lastSortedColumnIndex ){		
			//we have been sorted the same column just before current sort - we need only to reverse the table rows
			this.reverseRows();
			this.updateSortImgAndCaptions(selectedColumnIndex);
			
		}else{	
			//we are sorting the table for first time	
			//first sort mode is ASC
			this.performAscSort(selectedColumnIndex, columnDataType);
			this.state.lastSortedColumnIndex = selectedColumnIndex;
			this.state.lastSortedColumnType = columnDataType;
			this.serializeState();
		}
		
		endTime = new Date().getTime();
		//console.log('Elapsed time ' + ((endTime - startTime)) + ' miliseconds.');
	}

	function sortColumn( tableRowsArray, adminTable, selectedColumnIndex, comparatorFunc, columnDataType ){
		adminTable.innerTexts = new Array(tableRowsArray.length + 1);
		for (var i = 0; i < tableRowsArray.length; i++) {
			var columnValue = getInnerText(tableRowsArray[i].cells[selectedColumnIndex]);
			if(columnDataType == INT_COLUMN_DATATYPE) {
				columnValue = getNumber(columnValue);
			}
			adminTable.innerTexts[tableRowsArray[i].rowIndex] = columnValue;
		}
		quicksort(adminTable.innerTexts, tableRowsArray, 0, tableRowsArray.length, comparatorFunc);
	}

	//append sorted arrays to the table
	function appendTableRows(rowsArray){
		
		var tbody = this.table.getElementsByTagName('TBODY')[0];
		var filteredIndex = 0;
		for (var p = 0; p < rowsArray.length; p++) { 
			var rowItem = rowsArray[p];
			//alternating rows
			if(rowItem.style.display != 'none'){
				//empty tables should not be filtered (None should stay visible when there isn't any other visible rows)
				if (rowItem.className != "isc-table-row-none-hidden" && rowItem.className != "isc-table-row-none" ){

					rowItem.className = (filteredIndex++) % 2 == 0 ? "isc-table-row": "isc-table-row-alternate";
					//iscHighLightParentRow(elements[i],tmpForm,spanId);
				}
			}
			tbody.appendChild(rowItem);
		}	

	}
	
	//adjust height 223147
	function appendFillerRows(){
//		var rowsArray = this.getTableRowsAsArray();
		
		var tbody = this.table.getElementsByTagName('TBODY')[0];
		var	fillerHeight = dojo.style( tbody, 'height' );
		for (var i = 0; i < tbody.rows.length; i++) { 
			var rowItem = tbody.rows[i];
			//alternating rows
			if(rowItem.style.display != 'none'){
				if (rowItem.className != "isc-table-row-none-hidden"){
					//each row is 27 pixels
					fillerHeight = fillerHeight - 27;
					
				}
			}
		}	
		//need to append an empty row for FF3 so that the rows get the right height
		if (fillerHeight > 0){
			//need to get number of columns
			var thead = this.table.getElementsByTagName("thead")[0];
			var headerRow = thead.getElementsByTagName("tr")[0];
			var headerColumns = headerRow.getElementsByTagName("th");
			
			var rowFiller = document.createElement("tr");
			rowFiller.setAttribute("style", "height:"+fillerHeight);
			rowFiller.setAttribute("class", "isc-table-row-none");
			var tdFiller = document.createElement("td");
			rowFiller.appendChild(tdFiller);
			tdFiller.setAttribute("class", "isc-table-message");
			tdFiller.setAttribute("width", "100%");
			tdFiller.setAttribute("colspan",headerColumns.length);			
			tdFiller.setAttribute("valign", "absmiddle");
			tbody.appendChild(rowFiller);
		
		}
	}
	
	//reverse tables rows
	function reverseRows(){
		var tableRowsArray = this.getTableRowsAsArray();
		
		if(this.isHierarchical()){
			var reversedRows = new Array();
			for (var key in tableRowsArray) {
				tableRowsArray[key].reverse();
			}
			reversedRows = concatHierarchicalRows(tableRowsArray, 'RootNode');
			this.appendTableRows(reversedRows);
		}else if(this.isFlat()){
			tableRowsArray.reverse();
			this.appendTableRows(tableRowsArray);
		}else{
			console.debug("Unknown table type");
		}
		
	}
	
	//construct an Array object with the table rows (TR). The Array is needed for built-in sort function
	function getTableRowsAsArray(){
		
		var tableRows = new Array();
		var tbody = this.table.getElementsByTagName('TBODY')[0];
		
		if(this.isHierarchical()){
			//in this case the tableRows array is a two-dimensional array
			for (var i = 0; i < tbody.rows.length; i++) { 
				var rowValues = tbody.rows[i].id.split('^');
				
				var parentNodeId = rowValues[1];
				var nodeId = rowValues[2];
				
				if(!tableRows[parentNodeId]){
					tableRows[parentNodeId] = new Array(tbody.rows[i]);
				}else{
					tableRows[parentNodeId] = tableRows[parentNodeId].concat(tbody.rows[i]);
				}
			}
			
		}else if(this.isFlat()){
			//in this case the tableRows array is a one-dimensional array
			for (var i = 0; i < tbody.rows.length; i++) { 
				tableRows[i] = tbody.rows[i]; 
			}
		
		}else{
			console.debug("Unknown table type");
		}
		
		return tableRows;
		
	}
	
	//based on data type of column items, return appropriate comparator
	function getSortComparator(columnDataType){
		if(columnDataType == STRING_COLUMN_DATATYPE){
			return this.stringComparator;
		}else if(columnDataType == INT_COLUMN_DATATYPE){
			return this.intComparator;
		}else if(columnDataType == STRINGCOMBO_COLUMN_DATATYPE){
			return this.stringComboComparator;
		}
	}
	
		function exchange(tableRowsArray, i, j){
		var temp = tableRowsArray[ i ];
		tableRowsArray[ i ] = tableRowsArray[ j ];
		tableRowsArray[ j ] = temp;
	}

	function quicksort(innerTexts, tableRowsArray, low, high, comparatorFunc){
		if(high <= low + 1){
			return;
		} 
		 
		if((high - low) == 2){
			if( comparatorFunc(innerTexts[ tableRowsArray[high - 1].rowIndex ], 
					innerTexts[ tableRowsArray[low].rowIndex ] ) > 0 ){
				exchange(tableRowsArray, high - 1, low);
			}
			return;
		}
		
		var i = low + 1;
		var j = high - 1;
		
		if( comparatorFunc( innerTexts[ tableRowsArray[low].rowIndex ],
					innerTexts[ tableRowsArray[i].rowIndex ] ) > 0 ){
				exchange(tableRowsArray, i, low);
		} 	
				
		if( comparatorFunc( innerTexts[ tableRowsArray[j].rowIndex ],
					innerTexts[ tableRowsArray[low].rowIndex ] ) > 0 ){
				exchange(tableRowsArray, low, j);
		}
				
		if( comparatorFunc( innerTexts[ tableRowsArray[low].rowIndex ], 
					innerTexts[ tableRowsArray[i].rowIndex ] ) > 0  ){
				exchange(tableRowsArray, i, low);
		}
		
		var pivot = innerTexts[ tableRowsArray[ low ].rowIndex ];
		
		while(true) {
			j--;
			while( comparatorFunc( pivot, innerTexts[ tableRowsArray[ j ].rowIndex ] ) > 0 ){
				j--;
			}
			
			i++;
			while( comparatorFunc( innerTexts[ tableRowsArray[ i ].rowIndex ], pivot) > 0 ) {
				 i++;
			}
			
			if (j <= i) {
				break;
			}
			exchange(tableRowsArray, i, j);
		}
		exchange(tableRowsArray, low, j);
		
		if((j-low) < (high-j)){
			quicksort(innerTexts, tableRowsArray, low, j, comparatorFunc);
			quicksort(innerTexts, tableRowsArray, j+1, high, comparatorFunc);
		} else {
			quicksort(innerTexts, tableRowsArray, j+1, high, comparatorFunc);
			quicksort(innerTexts, tableRowsArray, low, j, comparatorFunc);
		}
	}
	
	/*--------------------------------------------------------------------------------
	 * We are assuming that filterable columns names are those columns which headers do not have the css class = 'isc-table-header-data-centered'. These are the numeric and text columns.
	 * Currently isc tables have not date columns, so it is posible that columns to be center aligned and filterable at the same time. Code changes in this method will be needed in this case
	 * Inputs:
	 * 	none
	 * Outputs:
	 * 	two dimensioanl array of column names and theirs indexes in the whole table
	 */
	function getFilterableTableColumnNames(){
		
		var columnsNames = new Array();
		
		var thead = this.table.getElementsByTagName("thead")[0];
		var headerRow = thead.getElementsByTagName("tr")[0];
		var headerColumns = headerRow.getElementsByTagName("th");
		
		var index = 0;
		for( i = 0; i < headerColumns.length; i++ ){
			
			/* we exclude the table headers that are centered, because these columns contains only checkboxes and radio buttons and we can not filter them */
			if(headerColumns[i].className != 'isc-table-header-data-centered'){
				anchors = headerColumns[i].getElementsByTagName("a");
				if(anchors.length > 0){
					//we use two dimensional array for keeping the name of the columns as well as the index of the column in the table
					columnsNames[index] = new Array(2);
					columnsNames[index][0] = i; // i is the index of the entire table, it does not coinside with the index of the columnNames
					columnsNames[index][1] = headerColumns[i].getElementsByTagName("a")[0].innerHTML.trim();
					index++;
				}
				
			}
		}
	
		return columnsNames;
    
	}

	/*---------------------------------------------------------
	* Compare function for columns with String data used in sorting
	* The sort column is specified by "currentSortedColumnIndex" property of AdminTableState object
	* Inputs:	
	*	a - string 
	* 	b - string
	* Returns:
	*	b > a -> result>0
	*	b < a -> result< 0
	*	b == a -> result= 0
	*/
	function stringComparator(a, b){
		
		var el1 = "";
		var el2 = "";
		if (! (a == null || typeof a == 'undefined') ) {
			el1 = a.toLowerCase();
		}
		if (! (b == null || typeof b == 'undefined') ) {
			el2 = b.toLowerCase();
		}
		
		if (el1 == el2) {
			return 0;
		} else if (el1 < el2) {
			return 1;
		} else {
			return -1;
		}
	}
	
	/*---------------------------------------------------------
	* Returns the first found number from string input separated by space character ' '
	* Inputs:	
	*	str- string or number
	* Returns: number - default value 0
	*/
	function getNumber(str) {
		var result = 0;
		
		if (str == null || typeof str == 'undefined') {
			return result;
		}
		
		if (! (typeof str == 'string') ) {
			return result;
		}
		
		//split string str by character space ' '
		var numberStringArray = str.split(' ');
		
		for(var i = 0; i < numberStringArray.length;i++) {
			//get current string token
			var numberString = numberStringArray[i];
			//try to convert to number
			var numberValue = Number(numberString);
			//check is number
			if (!isNaN(numberValue)) {
				result = numberValue;
				break;
			}
		}
		return result;
	}// end of getNumber()

	/*--------------------------------------------------------------------------------
	* Compare function for columns with Int data used in sorting.
	* Inputs:
	*	 a - int value from sortable table column
	*	 b - int value from sortable table column
	* Returns:
	*	b > a -> result>0
	*	b < a -> result< 0
	*	b == a -> result= 0
	*/
	function intComparator(a, b){
		var result = b-a;
		return result;
	}
	
	/*-------------------------------------------------------------------
	* Compare function for columns with String data filled in a combo box .
	* Inputs:
	*	a - string 
	* 	b - string
	* Returns:
	*	b > a -> result>0
	*	b < a -> result< 0
	*	b == a -> result= 0
	*/
	function stringComboComparator(a, b){
		var el1 = "";
		var el2 = "";
		if (! (a == null || typeof a == 'undefined') ) {
			el1 = a.toLowerCase();
		}
		if (! (b == null || typeof b == 'undefined') ) {
			el2 = b.toLowerCase();
		}
		
		if (el1 == el2) {
			return 0;
		} else if (el2<el1) {
			return -1;
		} else {
			return 1;
		}
	}
	
	/*---------------------------------------------------------
	* Changing the sort icon and sort text from ascending to descending and vice versa when a column is clicked several times.
	*Inputs:
	*	selectedColumnIndex - column index in the table
	*/
	function updateSortImgAndCaptions(selectedColumnIndex){
		
		var thead = this.table.getElementsByTagName("thead")[0];
		var headerRow = thead.getElementsByTagName("tr")[0];
		var headerColumns = headerRow.getElementsByTagName("th");
		var linkElement = headerColumns[selectedColumnIndex].getElementsByTagName('a')[0];
		
		if(linkElement && linkElement.parentNode.getElementsByTagName('IMG').length > 0){
			
			var sortImg = linkElement.parentNode.getElementsByTagName('IMG')[0];
			
			if(sortImg.src.indexOf(this.ascSortImagePath) != -1){
				this.setSortImgAndCaptions(selectedColumnIndex, this.descSortImagePath, getDescendingSortTitle());
			}else if(sortImg.src.indexOf(this.descSortImagePath) != -1){
				this.setSortImgAndCaptions(selectedColumnIndex, this.ascSortImagePath, getAscendingSortTitle());
			}
		}
	}
	
	/*------------------------------------------------------------------
	* Set particular sort icon and caption title (tooltip)
	* Inputs:
	*	selectedColumnIndex - column index in the table
	* 	sortImgPath - the physical path (src) of the sort icon
	* 	sortCaptionTitle - string to be displayed as a title when mouse is hover over the sort column	
	*/
	function setSortImgAndCaptions(selectedColumnIndex, sortImgPath, sortCaptionTitle){
		var thead = this.table.getElementsByTagName("thead")[0];
		var headerRow = thead.getElementsByTagName("tr")[0];
		var headerColumns = headerRow.getElementsByTagName("th");
		var linkElement = headerColumns[selectedColumnIndex].getElementsByTagName('a')[0];
		
		if(linkElement && linkElement.parentNode.getElementsByTagName('IMG').length > 0){
			
			var sortImg = linkElement.parentNode.getElementsByTagName('IMG')[0];
			
			sortImg.src = sortImgPath;
			sortImg.title = sortCaptionTitle;
			sortImg.alt = sortCaptionTitle;
			linkElement.title = sortCaptionTitle;
			linkElement.alt = sortCaptionTitle;
			
			if(sortImgPath != this.defSortImagePath){
				this.state.sortOrderImagePath = sortImg.src;
				this.serializeState();
				
				//remove the sort icon from other headers
				for(var k = 0; k < headerColumns.length; ++k ){
					if( k != selectedColumnIndex){
						var sortLink = headerColumns[k].getElementsByTagName('a')[0];
						this.setSortImgAndCaptions(k, this.defSortImagePath, getDefaultSortTitle());
					}
				}
			}
		}
	}
	
	/*-----------------------------------------------------------------------
	 * Return the index of the column in the entire table that is filtering in order to
	 * Inputs:
	 * 	columnName - the name of the filterable column
	 *       tableId - the id of the table
	 * Outputs:
	 * 	the index of the filterable column in the entire table 
	 *	-1 for an error
	 */
	function getColumnNameIndex(columnName){
		
		var filterableColumnArray = this.getFilterableTableColumnNames();
		
		for(var i = 0; i < filterableColumnArray.length; i++ ){
			if(filterableColumnArray[i][1] == columnName){
				return filterableColumnArray[i][0];
			}
		}
		
		return -1;
	}
	
	/*------------------------------------------
	 * Return an array of the column indexes that have been selected for filtering
	 */
	function getSelectedColumnIndexes(){
		
		var selectedColumns = this.getState().filteringColumns;
		var columnIndexes = selectedColumns.split(this.SELECTED_COLUMNS_DELIMITER);
		
		return  columnIndexes;
	} 
	
	/*------------------------------------------
	 * All flat tables have a column that is sorted by default. This method gets the first string column and performs sorting on it
	 */
	function performDefaultSort(){
		
		if(this.isFlat()){
			var thElements = this.table.getElementsByTagName('TH');
			var defaultSortColumnIndex = 0;
			
			for(defaultSortColumnIndex = 0; defaultSortColumnIndex < thElements.length; defaultSortColumnIndex++){
				if(thElements[defaultSortColumnIndex].className != "isc-table-header-data-centered"){
					thElement = thElements[defaultSortColumnIndex];
					break;
				}
			}
			//this.sort(defaultSortColumnIndex, STRING_COLUMN_DATATYPE);	
			this.performAscSort(defaultSortColumnIndex, STRING_COLUMN_DATATYPE);	
		}
		
	}
	
	/*---------------------------------------------------------------
	 * AdminTable.exploreNodeWithKey
	 *
	 * Leverage recursion to walk all elements from the given root
	 * looking for TextNodes. When it finds a match to the given
	 * key it stop looking. Yes, this is short circuit logic.
	 *
	 * This method assumes that key is in all lowercase and runs
	 * an indexOf comparions to determine a match. Using the 
	 * JavaScript match or search method has some side effects
	 * that our might not understand. 
	 *
	 * Inputs:
	 *  el - DOM element to evaluate
	 *  key - Key to compare the text.
	 *
	 * Outputs:
	 *   True when the key is find in any children elements of the
	 *   inital DOM element. Otherwise, false.
	 *
	 * Side Effects:
	 *   None.
	 *  
	 *---------------------------------------------------------------*/
	function exploreNodeWithKey( el, key ){
		//text element
		if( el.nodeValue != null ){
		    if( el.nodeValue.containsValue( key )) {
		        return true;
		    }
		}
		
		var tagName = (el.tagName != null) ? el.tagName.toLowerCase() : '';
		var type = (el.type != null) ? el.type.toLowerCase() : '';
		
		//select element
		if(tagName == "select"){
		   if (checkSelect(el, key)){
				return true;
		   }else{
				return false;
		   }
		}else if (tagName == "input" && type == "text"){
		//input element of type text
			if(el.value != null && el.value.containsValue(key)){
				return true;
			}
		}
		
		// expore children
		if( el.hasChildNodes() ){
			var i;
			// Search till a match is found
		    for( i = 0; i < el.childNodes.length; i++ ){
			    var child = el.childNodes[i];
				try{
					var keyFound = this.exploreNodeWithKey( child, key );
					if (keyFound){
						return true;
					}
				}catch( e ){
					console.log("Error parsing element tree");
				}
			}
		}
		  //trace( "[exploreNodeWithKey] keyFound is " + keyFound );
		return false;
	}
	
	function checkSelect(select, key){
		var selectedText = select.value;
		if (select.type == "select-one"){
			if (select.options != null){
				if (select.selectedIndex >= 0 && select.selectedIndex < select.options.length){
					selectedText = select.options[select.selectedIndex].text;
				}
			}
		}
		if(selectedText != null && selectedText.containsValue(key)){
			return true;
		}
		return false;
	}
	
	/*------------------------------------------------------
	* Perform table filtering
	* Inputs:
	*	filterStr - the string to search for
	* Outputs:
	*	none
	*/
	function filter(filterStr){
		//startTime = new Date().getTime();
		var expandFilter = (filterStr.indexOf(this.state.filterString) == 0);
		var tbody = this.table.getElementsByTagName( "tbody" )[0];
		var rows = tbody.getElementsByTagName( "tr" );
		var i, j;
		var isEmpty = true;
		var noneIndex = -1;
		
		//the column ids that were selected from the popup menu for filtering 
		var selectedColumns = this.getSelectedColumnIndexes();
		// Walk all the rows in the table
		for( i = 0; i < rows.length; i++ ) {
			
			if (rows[i].className == "isc-table-row-none" || rows[i].className == "isc-table-row-none-hidden"){
				noneIndex = i;
			}
			
			//leave rows that are already filtered out
			//if we toggle the checks the filter word is the same but now we're filtering on different columns
			if ( this.state.filterChecksToggled == false )
			if (expandFilter &&  (rows[i].className == "isc-row-filtered" || 
					rows[i].className == "isc-row-filtered-hidden")){
				continue;			
			}
			//the TBODY contains other TR elements except the base table rows.
			if(rows[i].className == "isc-table-row" || 
					rows[i].className == "isc-table-row-alternate" || 
					rows[i].className == "isc-row-filtered" || 
					rows[i].className == "isc-row-filtered-hidden" || 
					rows[i].className == "isc-table-row-selected-alt" || 
					rows[i].className == "isc-table-row-selected"){
				var cells = rows[i].getElementsByTagName( "td" );
				
				//remove nested cells that appear as top-level cells from the array 
				var newCells = new Array(cells.length);
				var newCellsCounter = 0;
				for (cellCounter = 0; cellCounter < cells.length; cellCounter++) {
					newCells[newCellsCounter] = cells[cellCounter];
					newCellsCounter++;
					if(cells[cellCounter].getElementsByTagName("td").length != 0) {
						cellCounter += cells[cellCounter].getElementsByTagName("td").length;
					}
				}
				cells = newCells;
				
				var display = false;
				
				// reset state so show all the rows in the table again
				if(rows[i].className == "isc-row-filtered"){
					rows[i].style.display = (dojo.isIE) ? "block" : "table-row";
				}
					
				rows[i].className = "isc-table-row";
					
				// Try to prevent uncessary walking of the table.
				if( filterStr != "" ){
					// Walk all table cells looking for the filter value
					for( j = 0; j < cells.length && !display; j++ ){
					   //if the column is not selected - do not filer on this column
					   if(isColumnSelected(j, selectedColumns) == -1){
							continue;
					   }
					   // Explore each cell looking for a match
						display = this.exploreNodeWithKey( cells[j], filterStr );
					}
				
					if (!display){
						if(rows[i].style.display != "none"){
							rows[i].style.display = "none";
							rows[i].className = "isc-row-filtered";
						}else if(rows[i].className != "isc-row-filtered"){
							rows[i].className = "isc-row-filtered-hidden";
						}
					}else{
						this.tableRowFiltered(rows[i]);//, displayedIndex
						isEmpty = false;
					}
				}else{
					isEmpty = false;
				}
			}
		}
		iscAlternateTableRows(this.id);
		
		if(noneIndex > -1){
			if(isEmpty){
				rows[noneIndex].className = "isc-table-row-none";
			}else{
				rows[noneIndex].className = "isc-table-row-none-hidden";
			}
		}
		  
		this.state.filterString = filterStr;
		this.serializeState();
		  
		//endTime = new Date().getTime();
		//console.log('Elapsed time ' + ((endTime - startTime)) + ' miliseconds.');
	}
	
	/*-----------------------------------------------------------------------------------
	 * This method creates the list with column names in the table filter popup.
	 * It iterates throught the table heading columns and get their titles.
	 * 
	 * Inputs:
	 *
	 * Outputs:
	 *  Modify the DOM tree, adding the table header names to the list
	 *
	 * Side Effects:
	 *   None.
	*/
	function createFilterDropdownMenu(){
		
		/* div element holding the popup menu */
		var popupMenu = document.getElementById(this.FILTER_DROPDOWN_ID);
	    var dynamicList = null;

	    if (popupMenu){
	        dynamicList = popupMenu.childNodes[0];
	    }
	    
		/* the popup contains always at least two childs (Filter On, All), this test if we had already constructed the popup menu   */			
		if(!dynamicList || dynamicList.childNodes.length > 2){
			return;
		}
		
		var filterableColumnNames = this.getFilterableTableColumnNames();
		
		/*Adds default filter - All*/
		if(this.state.filteringColumns == ''){
			var indexesString = '';
			for(var i = 0; i < filterableColumnNames.length; i++){	
				indexesString += filterableColumnNames[i][0];
				if(i < (filterableColumnNames.length - 1)){
					indexesString += this.SELECTED_COLUMNS_DELIMITER;
				}
			}
		
			this.state.filteringColumns = indexesString;
			this.serializeState();
		}
		
		/* hide the popupMenu if we have only one or none filterable column */
		if(filterableColumnNames.length <= 1){
			dojo.style(popupMenu.parentNode,"display","none");
			dojo.style(popupMenu.parentNode.parentNode,"cursor","default");
		}
		
		
		
		for(var i = 0; i < filterableColumnNames.length; i++){	
		
			var columnIndex = filterableColumnNames[i][0];
			var columnName = filterableColumnNames[i][1];
			
			var ddElem = document.createElement("dd");
			var label = document.createElement("label");
		
			label.onclick = getToggleFilterableColumnFunc(label, this);
			
			/* image for selecting a filterable column name */
			tick = document.createElement("img");
			tick.setAttribute("src", this.columnNotSelectedForFilteringImagePath);
				
			/* the table column name */
			//defect 207059
			var columnNameLink = document.createElement("a");
			
			var span = document.createElement("span");

			var columnName = document.createTextNode(columnName);
			span.appendChild(columnName);

			columnNameLink.appendChild(span);
			columnNameLink.href = "javascript:void(0)";
				
			label.appendChild(tick);
			label.appendChild(columnNameLink);
			ddElem.appendChild(label);
			dynamicList.appendChild(ddElem);
		}
	}
	
	
	/*---------------------------------------------------------------------------------
	 * Make the column filterable/non-filterable
	 * Inputs:
	 *	label - HTML element label representing a row item in the popup menu 
	 * Ouputs:
	 * 	none	
	 * Side effects:
	 *	 the state of the table is updated
	 */
	function toggleFilterableColumn(label){
	
		if(label.id == this.FILTER_ALL_OPTION_ID){
			//All option is selected
			if(label.childNodes[0].src.indexOf(this.columnNotSelectedForFilteringImagePath) != -1){
				var filterableColumnNames = this.getFilterableTableColumnNames();
				var allColumnIndexes = new Array();
				for(var k = 0; k < filterableColumnNames.length; k++){
					allColumnIndexes[k] = filterableColumnNames[k][0];
				}
				this.state.filteringColumns = allColumnIndexes.join(this.SELECTED_COLUMNS_DELIMITER);
				label.childNodes[0].src = this.columnSelectedForFilteringImagePath;
			}
			
			//parent is a DD element
			var parent = label.parentNode;
			parent = parent.nextSibling;
			while(parent){
				parent.childNodes[0].childNodes[0].src = this.columnNotSelectedForFilteringImagePath;
				parent = parent.nextSibling;
			}		
			
			this.state.filterChecksToggled = true;
			this.filter( this.state.filterString );
			this.state.filterChecksToggled = false;
		}else{
		
			//we have to unselect the 'All' option
			var allOption = document.getElementById(this.FILTER_ALL_OPTION_ID);
			if(allOption.childNodes[0].src.indexOf(this.columnNotSelectedForFilteringImagePath) == -1){
				allOption.childNodes[0].src = this.columnNotSelectedForFilteringImagePath;
				this.state.filteringColumns = '';
			}
			
			var tick = label.childNodes[0];
			//<a href="javasript:void(0)><span>columnName</span></a>
			var columnName = label.childNodes[1].childNodes[0].innerHTML.trim();
			var selectedColumns = this.state.filteringColumns;
			var selectedColumnIndexes = (selectedColumns == '') ? new Array() : selectedColumns.split(this.SELECTED_COLUMNS_DELIMITER); 
			var columnIndex = this.getColumnNameIndex(columnName);
			
			if(tick.src.indexOf(this.columnNotSelectedForFilteringImagePath) != -1 ){
				tick.src = this.columnSelectedForFilteringImagePath;
				//add the column to the list of filterable columns
				selectedColumns += ((selectedColumnIndexes.length > 0) ? this.SELECTED_COLUMNS_DELIMITER : "") + columnIndex;
				this.state.filteringColumns = selectedColumns;
			
			}else if((tick.src.indexOf(this.columnSelectedForFilteringImagePath) != -1 ) && this.isTickUncheckAllowed(label)){
				tick.src = this.columnNotSelectedForFilteringImagePath;
				//we want to remove the selected column name from the list of the filterable columns
				
				var indexOfTheSelectedColumn = isColumnSelected(columnIndex, selectedColumnIndexes);
				if(indexOfTheSelectedColumn != -1){
					selectedColumnIndexes.splice(indexOfTheSelectedColumn, 1);
				}
				
				this.state.filteringColumns = selectedColumnIndexes.join(this.SELECTED_COLUMNS_DELIMITER);
			}
			this.state.filterChecksToggled = true;
			this.filter( this.state.filterString );
			this.state.filterChecksToggled = false;
		}
		
		this.serializeState();
		
	}

	function toggleFilterableColumns(filteringColumns){
		
		if(filteringColumns != ''){
			var filterDropdown = document.getElementById(this.FILTER_DROPDOWN_ID);
			//<DL> element that holds filterable columns
			var dynamicList = filterDropdown.childNodes[0];
			var allFilterableColumns = this.getFilterableTableColumnNames();
			
			if(filteringColumns.split(this.SELECTED_COLUMNS_DELIMITER).length != allFilterableColumns.length){
				//If not all columns had been selected, you leave the "All" option which is selected by default
				
				//The very first child node of the dynamic list is DT, the second is the "All" options that is defined in the quickFilter.jsp
				for(var i=2; i < dynamicList.childNodes.length; i++){
					if(filteringColumns.indexOf(i - 1) != -1){
						var label = dynamicList.childNodes[i].getElementsByTagName('LABEL')[0];
						this.toggleFilterableColumn(label);
					}
				}
			}
		}
	}
	
	function getToggleFilterableColumnFunc(label, tableDataObj){
		return function(){
			new AdminTable(tableDataObj.table).toggleFilterableColumn(label);
			//tableDataObj.toggleFilterableColumn(label);
		}
	}
	
	
	
	/*-------------------------------------------------------
	 * This function is inkoved when a certain row matches filter criteria
	 * INPUT: tableType - the type of the table (0 - flat table; 1 - hierarchical table)
	 *	       row - TR DOM object of the matched table row
	 */
	function tableRowFiltered(row){
		
		if(this.isHierarchical()){
			//hieararchical table
			var idTokens = row.id.split('^');
			var parentNodeId = idTokens[1];
			var prev = row.previousSibling;
			
			//if prev is text node, go to next TR element
			while(prev != null && prev.nodeType == 3){
				prev = prev.previousSibling;
			}
			
			if(prev == null){
				return;
			}
			
			var upperSiblingId = prev.id.split('^')[2];
			var upperSiblingParentId = prev.id.split('^')[1];

			//we must keep visible all the parent nodes of a row that match filter criteria
			do{

				if(parentNodeId == upperSiblingId){
					if(prev.className == 'isc-row-filtered-hidden'){
						prev.className = 'isc-table-row';
					}
					if(prev.className == 'isc-row-filtered'){
						prev.className = 'isc-table-row';
						prev.style.display = (dojo.isIE)?'block':"table-row";
					}

					parentNodeId = upperSiblingParentId;
				}
				
				var prev = prev.previousSibling;
				//if prev is text node, go to next TR element
				while(prev != null && prev.nodeType == 3){
					prev = prev.previousSibling;
				}
				
				if(prev != null){
					upperSiblingId = prev.id.split('^')[2];
					upperSiblingParentId = prev.id.split('^')[2];
				}
				
			}while(upperSiblingParentId != 'RootNode' && prev != null)
			
			//prev is the parent
			if(prev != null){
				prev.style.display = (dojo.isIE)?"block":"table-row";
				prev.className = "isc-table-row";
			}
		}
	}

	/*----------------------------------------------------------------------------------------------
	* Returns all expanded nodes for hierarchical tables in order to be kept in the table state when the table is unloading
	* TODO: if a node in level > 1 in the tree is expanded and its parent is collapsed then on loading table state the node is not displayed properly. On load table state we have to check for parent nodes collapsion.
	*/
	function getExpandedNodes(){
		if(this.isHierarchical()){
			var list = "";
			var images = this.table.getElementsByTagName('IMG');
			for(var k = 0; k < images.length; k++){
				var img = images[k];
				if(img.id && img.id.indexOf('^exp^') != -1){
					//alert(img.id);
					list += (list == "" ? img.id : "," + img.id);
				}
			}
			return list;
		}else{
			return "";
		}
	}
	
} //AdminTable

	
	
//====================Global Functions========================

//returns title for descenting sort order
function getDescendingSortTitle() {
	var descSortTitle = '';

	var detailFrame = window.parent.frames['detail'];
	if (detailFrame != null && detailFrame.descSortTitle != null) {
		descSortTitle = detailFrame.descSortTitle;
	}
	return descSortTitle;
}

//returns title for ascending sort order
function getAscendingSortTitle() {
	var ascSortTitle = '';

	var detailFrame = window.parent.frames['detail'];
	if (detailFrame != null && detailFrame.ascSortTitle != null) {
		ascSortTitle = detailFrame.ascSortTitle;
	}
	return ascSortTitle;
}

//returns title for unsort(default) sort order
function getDefaultSortTitle() {
	var defSortTitle = '';

	var detailFrame = window.parent.frames['detail'];
	if (detailFrame != null && detailFrame.defSortTitle != null) {
		defSortTitle = detailFrame.defSortTitle;
	}
	return defSortTitle;
}

function getAncestorByName(element, elementName) {
	var result = null;
	var eName = elementName.toLowerCase();
	try{
		while(result == null && element != null){
			element = element.parentNode;
			if(element.nodeName.toLowerCase()== eName){
				result = element;
			}
		}
	}catch(e) {
		//wasn't a node
	}
	return(result);
} 
	
	
function quickFilterFocus(inputElement, popupMenuId, promptMessage) {

	if(inputElement.value == promptMessage){
		inputElement.value='';
		inputElement.className = 'qf-textfield'; 
	}
	
	//on input search focus we must hide the popup menu, because otherwise it enlarges the table column height
	var popupMenu = document.getElementById(popupMenuId);
	var element = getAncestorByName(inputElement, "div");
}
	
function quickFilterDefault(inputElement, promptMessage) {

	if(inputElement.value==''){
		inputElement.value = promptMessage;
		inputElement.className = 'qf-textfield-label';
	}
	
	var element = getAncestorByName(inputElement, "div");
	element.className="quick-filter";
}

function quickFilterOver(inputElement) {
	var element = getAncestorByName(inputElement, "div");
	element.className = "quick-filter-over";
}

/*---------------------------------------------------------------
 * filterTable
 *
 * Handle the keyUp event on an input element to start a 
 * filter operation of a given table id. 
 *
 * Inputs:
 *  inputElement - Element causing the key up event
 *  tableId - Id of the table we want to filter 
 *
 * Outputs:
 *   None.
 *
 * Side Effects:
 *   Attaches a AdminTable object to the inputElement.
 *   This method also kicks off a background thread to 
 *   perform the filter.
 *  
 *---------------------------------------------------------------*/
function filterTable( inputElement, tableId){
  
  if( inputElement == null || tableId == null ){
    return;
  }
  
  if (timer == null ){
  	timer = setTimeout("handleFilter('" + inputElement.value + "', '" + tableId + "')", 500);
  }else{
  	clearTimeout(timer);
	timer = setTimeout("handleFilter('" + inputElement.value + "', '" + tableId + "')", 500);
  }
}

function handleFilter(filterStr, tableId){
	var table = document.getElementById(tableId);
	var dataObject = new AdminTable(table);
	if (dataObject.filterString != filterStr){
		dataObject.filter(filterStr);
	}
	timer = null;
}

/*---------------------------------------------------------------
 * sortTable
 *
 * Inputs:
 *  columnHeader - the header that was pressed to perform sorting
 *  columnDataType - the type of the elements in the column . This might be 'string' and 'int' for now
 * Outputs:
 *   None.
 *
 * Side Effects:
 *  
 *---------------------------------------------------------------*/
function sortTable(columnHeader, columnDataType){
	
	if (!columnHeader){
	    return;
	}
	if(columnHeader.tagName.toLowerCase() != 'th'){
		console.debug( "ERROR: Improper use of the function. First argument must be TH element" );
	    return;
	}
	   
	var linkElement = columnHeader.getElementsByTagName('a')[0];
	var parent = columnHeader.parentNode;
	while(parent != null && typeof(parent) != 'undefined' && parent.tagName.toLowerCase() != 'table'){
		parent = parent.parentNode;
	}
	  
	if( parent.id == null ){
	    console.debug( "ERROR: Unable to locate the input element or table id" );
	    return;
	}
	  
	var table = document.getElementById(parent.id);
	if( table != null ){
  
		var headers = table.getElementsByTagName('TH');
		var selectedColumnIndex = -1;
		  
		for(i = 0; i < headers.length; i++){
			if(headers[i].id == columnHeader.id){
				selectedColumnIndex = i;
				var dataObject = new AdminTable(table);
				dataObject.sort(selectedColumnIndex, columnDataType); 
				break;
			}
		}
	}
		
}

//the following function checks if unchecking a tick in the filter drop down menu should be allowed. It isn't allowed when this is the only checked one, and is whenever there're more than one ticks
function isTickUncheckAllowed(label){
	var labelParent; // shoud be dd element
	count=1;
	labelParent = label.parentNode;
	nextSibl = labelParent.nextSibling;	
	while(nextSibl != null){
		if (nextSibl.childNodes[0].childNodes[0].src.indexOf(this.columnSelectedForFilteringImagePath) != -1){
			count++;
		}
		nextSibl = nextSibl.nextSibling;
	}
	labelParent = label.parentNode;
	prevSibl = labelParent.previousSibling;
	while(prevSibl.tagName.toLowerCase() == "dd"){
		if(prevSibl.childNodes[0].childNodes[0].src.indexOf(this.columnSelectedForFilteringImagePath) != -1){
			count++;
		}
		prevSibl = prevSibl.previousSibling;
	}
	if (count > 1){
		return true;
	}
	else{
		return false;
	}
}

/*-------------------------------------------------------------------------
 * Check if the column name specified by the argument "columnName" has already been selected for filterable column.
 *  Inputs:
 * 	columnIndex - the index of the column in the entire table	
 * 	selectedColumnIndexes - array of those column indexes, that have been selected for filterable from the popup menu
 * Outputs:
 *	return the index of the column with name 'columnName' in the array of the selected columns for filtering
 */
function isColumnSelected(columnIndex, selectedColumnIndexes){
	
	var found = false;
	for(var i = 0; i < selectedColumnIndexes.length; i++){
		if(selectedColumnIndexes[i] == columnIndex){
			found = true;
			break;
		}
	}
	if(!found){
		i = -1;
	}
	return i;
}

/*----------------------------------------------------------------------------
* Performce HTML unescape, toLowerCase and replaces char non-breaking space 160 with space 32.
*/ 
function convertHtmlToString(str) {
	
	if (str == null || typeof str == 'undefined') {
		return str;
	}
	
	str = unescape(str.trim().toLowerCase());
	
	//replace &nbsp; html non-breaking space charachter 160 ' ' with ascii normal space character 32 ' '
	var str = str.trim().toLowerCase();
	var nonBreakingSpaceChar = String.fromCharCode(160);
	while (str.indexOf(nonBreakingSpaceChar) != -1) {
		str = str.replace(nonBreakingSpaceChar, ' ');
	}
	
	return str;
}

/*----------------------------------------------------------------------------
* Get the text value for an arbitrary html element. Uses helper method. Makes Html to String conversion
* Inputs:
*	el - HTML element that we are returning its text value
* TODO: use that function both for sorting and filtering to get the content for a table cell
*/
function getInnerText(el){

	var innerText = getInnerTextHelper(el);
	innerText = convertHtmlToString(innerText);
	return innerText;
}

/*----------------------------------------------------------------------------
* Get the text value for an arbitrary html element.
* Inputs:
*	el - HTML element that we are returning its text value
* TODO: use that function both for sorting and filtering to get the content for a table cell
*/
function getInnerTextHelper(el){
	var ELEMENT_NODE = 1;
	var TEXT_NODE = 3;
	
	if ('string' == typeof el || 'undefined' == typeof el) {
		return el;
	}
	
	//TextNode
	if (el.nodeType == TEXT_NODE) {
		return el.nodeValue;
	}
	
	var tagName = '';
	if (el.tagName) {
		tagName = el.tagName.toLowerCase();
	}
	var type = '';
	if (el.type) {
		type = el.type.toLowerCase();
	}

	if(tagName == "select") {
		//check if element is SELECT element for getting its value if so
		var selectedText = el.value;
		if (type == "select-one") {
			if (el.options != null) {
				if (el.selectedIndex >= 0 && el.selectedIndex < el.options.length) {
					selectedText = el.options[el.selectedIndex].text;
				}
			}
		}
		return selectedText;
	} 

	

	var cs = el.childNodes;
	var str = '';

	for (var i = 0; i < cs.length; i++) {

		if (cs[i].tagName && cs[i].tagName.toLowerCase() == "input" && cs[i].type && cs[i].type.toLowerCase() == "text") {
			//check if element is INPUT element of type TEXT for getting its value if so
			return cs[i].value;
		}
		if (cs[i].nodeType == ELEMENT_NODE) { 
			//came across ELEMENT - deep into its children to reach the innerText of the cell
			str = this.getInnerText(cs[i]);
			continue;
		}
		if (cs[i].nodeType == TEXT_NODE) { 
			if(cs[i].nodeValue.trim() == ''){
				//whitespaces are also counted for children in FF, that is why we by pass them
				continue;
			}else{
				str = cs[i].nodeValue;
				break;
			}
		}  
	}
	
	return str.trim();
}

function getComboSelectedText(el){
	var combo = el.getElementsByTagName('SELECT')[0];
	var selectedText = combo.options[combo.selectedIndex].text;
	return selectedText;
}

function concatHierarchicalRows(hierarchicalRows, parentNode){
		
	var mergedRows = new Array();
	if (hierarchicalRows[parentNode] != null) {
		for (var i=0; i < hierarchicalRows[parentNode].length; i++) { 
			var currentRow = hierarchicalRows[parentNode][i];
			var rowValues = currentRow.id.split('^');
			var parentNodeId = rowValues[1];
			var nodeId = rowValues[2];
			mergedRows = mergedRows.concat(currentRow);
			
			if((hierarchicalRows[nodeId]) && hierarchicalRows[nodeId].length != 0){
				var childRows = concatHierarchicalRows(hierarchicalRows, nodeId);
				mergedRows = mergedRows.concat(childRows);
			}
		}
	}
	
	return mergedRows;
}
