if(!dojo._hasResource["com.ibm.isclite.data.custom.eventsandwires.WireDNDManager"]){ 
dojo._hasResource["com.ibm.isclite.data.custom.eventsandwires.WireDNDManager"] = true;

dojo.provide("com.ibm.isclite.data.custom.eventsandwires.WireDNDManager");

dojo.declare(
    "com.ibm.isclite.data.custom.eventsandwires.WireDNDManager",
	null, 
{
	dropSubscription:null,
	
	destroy: function(){
		if (this.dropSubscription) {
			dojo.unsubscribe(this.dropSubscription);
			this.dropSubscription=null;
		}
	},

    constructor: function(){
    	this.dropSubscription = dojo.subscribe("/dnd/drop",  this, "handleDrop");
    },

    handleDrop: function(source,nodes,iscopy){
		
  		var target = dojo.dnd.manager().target;
		if (target == source) {
			return;
		} 
        
		if (dojo.hasClass(target.node, "wire-dnd-target-portlet")) {
			this.handlePortletDrop(source, target,nodes);
		}else if (dojo.hasClass(target.node, "wire-dnd-target-table")) {
			this.handleTableDrop(source, target,nodes);
		}else if (dojo.hasClass(target.node, "isc-table-header-data")) {
			this.handleTableHeaderDrop(source,target,nodes);
		}else if (dojo.hasClass(target.node, "isc-table-header")) {
			this.handleTableHeaderDrop(source,target,nodes);
		}
        
		var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
					
					
					var portletDiv = dojo.query("div[name='hideIframe']",pageDiv);
					
					if(portletDiv!=null){
						for(var i=0;i<portletDiv.length;i++){
							portletDiv[i].style.display="none";
						}
					
					}
    },

	getPortletDataNode:function(node) {

		if (node != null && node.firstChild != null) {
			return node.firstChild;
		}
		return null;
	},
	
	getPii:function(node) {
    
		var result = null;
        var array =  new Array();
        array = node.getElementsByTagName("table");
        // we expect array[0] to be the table element we need , may cause problems
        // TODO - find better solution
        eval( 'var pageDataObject = ' + array[0].getAttribute("portletdataObject") );
        result = pageDataObject.basePii;   
        
         //in new page use the map to get the correct pii
        // when editing page the map is empty
        //console.log('before',result);
        if(piiToPWIMap[result]){
            result = piiToPWIMap[result];
        }
       // console.log('after',result);                
		return result;
	},
	
	getWireTargetPortletTitle:function(parentNode) {
		
		var result = null;
		var query = ".isc-portlet-titletext";
		dojo.query(query, parentNode).forEach(function(node){

			for(var j = 0; j < node.childNodes.length; j++) {
				var childNode = node.childNodes[j];
				
				var id = childNode.id;
				if (id != null && id.indexOf("title.") == 0) {
				var titleDiv = dojo.query( 'div[name="portletTitleInnerDIV"]', childNode)[0];
				result = titleDiv.innerHTML;
				}
			}
		});
		return result;
	},
	
	getWindowUniqueName:function(node) {
		var result = null;
		var portletDataNode = this.getPortletDataNode(node);
        
       // used to work when page was refreshed each time a portlet was inserted
       // now it crashes firefox
		/*if (portletDataNode != null) {
			for(var i = 0; portletDataNode.childNodes.length; i++) {
				var node = portletDataNode.childNodes[i];
                 
				if (node != null && node.id != null && node.id != "") {
					var pageData = node.getAttribute("portletdataobject");
			        eval( 'var pageDataObject = ' + pageData );

			        result = pageDataObject.portletName;
					break;
				}
			}
		}*/
      //  if(result==null){
            var array =  new Array();
            array = node.getElementsByTagName("table");
            // we expect array[0] to be the table element we need , may cause problems
            // TODO - find better solution
            eval( 'var pageDataObject = ' + array[0].getAttribute("portletdataObject") );
            result=pageDataObject.portletName;
            if(!result){
                result=null;
            }
        //}
		return result;
	},
	
    handlePortletDrop: function(source, target, nodes) {
		for(var i = 0; i < nodes.length;i++) {
			var node = nodes[i];
			var nodeId = node.id;
			var sourceItem = source.getItem(nodeId);
			var data = sourceItem.data;
			var context = data;
			var piiValue = this.getPii(target.node);
			var titleValue = this.getWireTargetPortletTitle(target.node);
            //console.info('context',context);
			var navigationElementRefValue = context.wireSource.navigationElementRef;
            var uniquePageName = context.wireSource.uniquePageName;
			var windowUniqueNameValue = this.getWindowUniqueName(target.node);


			var wireTarget = {
				targetType: "1",
				wireTargetPortletTitle:titleValue,
				navigationElementRef: navigationElementRefValue,
				windowElementRef: windowUniqueNameValue,
				pii: piiValue,
				loadPage: "false",
				switchPage: "true"
			};
			
			context["wireTarget"] = wireTarget;

			customizer.controllerDispatch(uniquePageName,context,"checkWireExists");
		}
	},

    handleTableDrop: function(source, target, nodes) {
		for(var i = 0; i < nodes.length;i++) {
			var node = nodes[i];
			var nodeId = node.id;
			var sourceItem = source.getItem(nodeId);
			var data = sourceItem.data;
			var context = data;
			
			var wireTarget = target.node.getAttribute("wireTarget");
			eval( 'var wireTarget = ' + wireTarget);
			context["wireTarget"] = wireTarget;
			
			var uniquePageName = context.wireSource.uniquePageName;
			customizer.controllerDispatch(uniquePageName,context,"dropedWire");
		}
	},

	handleTableHeaderDrop: function(source, target, nodes) {
		for(var i = 0; i < nodes.length;i++) {
			var node = nodes[i];
			var nodeId = node.id;
			var sourceItem = source.getItem(nodeId);
			var data = sourceItem.data;
			var context = data;
			
			var wireTarget = target.node.getAttribute("wireTarget");
			eval( 'var wireTarget = ' + wireTarget);
			context["wireTarget"] = wireTarget;
			
			var uniquePageName = context.wireSource.uniquePageName;
			customizer.controllerDispatch(uniquePageName,context,"newWireTargetDialog");
		}
	}

});//com.ibm.isclite.data.custom.eventsandwires.WireDNDManager

}//has resource