/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/

dojo.provide("ibm.tivoli.tip.charts.dijit.ChartNavigator");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Form");
dojo.require("dijit.Toolbar");
dojo.require("dojo.io.iframe");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");
dojo.require("ibm.tivoli.tip.dijit.Breadcrumb");
dojo.require("ibm.tivoli.tip.charts.dijit.ConnectionManagerWidget");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartSelectorWidget");
dojo.require("ibm.tivoli.tip.dojo.Global");
dojo.require("ibm.tivoli.tip.dojo.Server");


// NLS
dojo.requireLocalization("ibm.tivoli.tip.charts.dijit", "chart_resources");
dojo.requireLocalization("ibm.tivoli.tip.charts.dijit", "chart_messages");


// define the widget class
dojo.declare(
	"ibm.tivoli.tip.charts.dijit.ChartNavigator", 
    [ dijit._Widget, dijit._Templated ],
{
    namespace_ : "namespace1_",
    chartSrcType_ : "",
    connectionName_ : "",
    groupID_ : "",
    chartID_ : "",
    global : null,
    widgetsInTemplate: true,
    CHART_SOURCE_TYPE_PAGE: "CHART_SOURCE_TYPE_PAGE",
    CONNECTION_MGR_PAGE: "CONNECTION_MGR_PAGE",
    WS_CHART_SELECTOR_PAGE: "WS_CHART_SELECTOR_PAGE",
    CUSTOM_CHART_SELECTOR_PAGE: "CUSTOM_CHART_SELECTOR_PAGE",
    CHART_PAGE: "CHART_PAGE",
    TABLE_PAGE: "TABLE_PAGE",
    templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/ChartNavigator.html"),

	constructor: function() {
		this.connectionMgr_ = null;
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.charts.dijit", "chart_resources");
   	    this.messages_ = dojo.i18n.getLocalization("ibm.tivoli.tip.charts.dijit", "chart_messages");
   	    this.tooltips = [];
   	    this.connections = [];
   	    this.topics = [];
   	    this.currentPage = this.CHART_SOURCE_TYPE_PAGE;
	},
	initialize: function() { 
	},
	postCreate: function() {
		this.inherited ("postCreate", arguments);
		this.global = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace_);
		
		var btn2 = dojo.byId (this.id + "tipServerChartSelectorBtn");
        this.connections.push (dojo.connect(btn2, 'onclick', this, 'onTipServerChartSelection'));
        var btn6 = dojo.byId (this.id + "downloadBIRTLink");
        this.connections.push (dojo.connect(btn6, 'onclick', this, 'downloadBIRTDesigner'));
        this.connections.push (dojo.connect(dojo.byId (this.id + "downloadBIRTButton"), 'onclick', this, 'downloadBIRTDesigner'));
        var btn7 = dojo.byId (this.id + "uploadButton");
        this.connections.push (dojo.connect(btn7, 'onclick', this, 'uploadChart'));
        
        this.connections.push (dojo.connect (dojo.byId (this.id + "homeImportChartIcon"), "onclick", this, "onImportChartType"));
        this.connections.push (dojo.connect (dojo.byId (this.id + "homeImportChartLink"), "onclick", this, "onImportChartType"));

        this.connections.push (dojo.connect (dojo.byId (this.id + "homeCustomChartIcon"), "onclick", this, "onCustomChartType"));
        this.connections.push (dojo.connect (dojo.byId (this.id + "homeCustomChartLink"), "onclick", this, "onCustomChartType"));

//        dojo.connect (dojo.byId (this.id + "homeDownloadBIRTIcon"), "onclick", this, "downloadBIRTDesigner");
//        dojo.connect (dojo.byId (this.id + "homeDownloadBIRTLink"), "onclick", this, "downloadBIRTDesigner");

        this.connections.push (dojo.connect (dojo.byId (this.id + "selectChartBack"), "onclick", this, 'showChartNavigator'));
        
        this.topics.push (dojo.subscribe ("/com.ibm.tivoli.tip.charts/" + this.namespace_ + "#showConnectionManager", this, "showConnectionManager"));
        
        this.handleRole();
        
        this.getPortletPreferences();
	},
	setCurrentPage: function (page) {
		this.currentPage = page;
	},
	getCurrentPage: function () {
		return this.currentPage;
	},
	getPortletPreferences: function () {
		var helper = new ibm.tivoli.tip.dojo.TIPHelper();
		var startNode = dojo.byId(this.id);
		var chartWidget = dijit.byId (this.namespace_ + "chartWidget");
		var errorHandler = { showMsg : true, callback: dojo.hitch (chartWidget, chartWidget.onError) };
		

		var kw = {
            content:   {
                  command: "getPreferences",
                  arg_portletNamespace: this.namespace_,
                  arg_chartProfileID: this.global.chartProfileID,
                  arg_pageName: helper.getPortletPageName(this.domNode),
                  arg_windowID: helper.getPortletWindowID(this.domNode),
                  arg_pageID: helper.getPortletPageID(this.domNode),
                  arg_load: "true"
            },
         	onExc: errorHandler,
       	    onResponse:{
                  callback: dojo.hitch(this, this.handleSavedPreferences)
       	    }
    	 };

		console.log ("making request getPreferences");	
		ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		
	},
	handleRole: function () {
		var context = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace_);
		if (context.roles.admin || context.roles.creator) {
			console.log ("administrator or creator role. enabling chart upload");
			dojo.byId(this.id + "downloadBIRTDiv").style.display = "";
		} else {
			console.log ("no administrator or creator role. disabling chart upload");
			// hide download/upload
			dojo.byId(this.id + "downloadBIRTDiv").style.display = "none";
			dojo.byId(this.id + "selectChartStep").innerHTML = this.resources_.SELECT_CHART;
			dojo.byId(this.id + "selectChartStep").title = this.resources_.SELECT_CHART;
			dojo.byId(this.id + "uploadDialogButton").style.display = "none";
			dojo.byId(this.id + "deleteCustomChartButton").style.display = "none";
			dojo.byId(this.id + "exportCustomChartButton").style.display = "none";
		}
	},
	downloadBIRTDesigner: function () {
		var url = "/ibm/TIPChartPortlet/birt/birt-designer.zip";
		window.open (url, "BIRTDesigner");
	},
	handleSavedPreferences: function (data, ioArgs) {
		console.log ("Enter handleSavedPreferences");
		this.chartSrcType_ = data.CHART_CONNECTION_TYPE;
		this.connectionName_ = data.CONNECTION_NAME;
		this.groupID_ = data.GROUP_ID;
		this.chartID_ = data.REPORT_NAME;
		var chartName = data.CHART_NAME;
		console.log (" with namespace: " + this.namespace_ + ", chartSrcType_: " + this.chartSrcType_ + ", connectionName: " + this.connectionName_ + ", groupID: " + this.groupID_ + ", chartID: " + this.chartID_);
		var doDefault = true;
		var srcTypeDiv = dojo.byId (this.id + "chartSourceTypeDiv");
		var webServiceRadio = dojo.byId (this.namespace_ + "tivoliApp");
		
		if (this.chartSrcType_ && (this.chartSrcType_ !== "") && (this.chartSrcType_ !== "null")) {
			if (this.chartSrcType_ == "TIPServer") {
				if (this.chartID_ && (this.chartID_ !== "") && (this.chartID_ !== "null")) {
					var tipServerRadio = dojo.byId (this.namespace_ + "tipServer");
					tipServerRadio.checked = true;
					srcTypeDiv.style.display = "none";
					this.populateTipServerChartSelector(true);
					var tipServerDiv = dojo.byId (this.id + "tipServerDiv");
					tipServerDiv.style.display = "none";
					doDefault = false;
				} else {
					doDefault = true;
				}
			} else if (this.chartSrcType_ == "WebService") {
				console.log ("rendering WebService:connectionName: " + this.connectionName_ + ", groupID: " + this.groupID_ + ", chartID: " + this.chartID_);
				webServiceRadio.checked = true;
				srcTypeDiv.style.display = "none";
				var selectorDiv = dojo.byId (this.namespace_ + "reportSelectorDiv");
				selectorDiv.style.display = "";
//				this.populateWebServicePath();
				this.handleWebServicePath(chartName);
				this.setWebServiceSubmitValues();
				doDefault = false;
			} else if (this.chartSrcType_ == "TivoliCommonReporting") {
				webServiceRadio.checked = true;
				srcTypeDiv.style.display = "none";
				this.populateTCRPath();
				doDefault = false;
			} else {
				console.error ("unknown chartSrcType: " + this.chartSrcType_);
				doDefault = true;
			}
		} else {
			console.log ("no chartSrcType: " + this.chartSrcType_);
		}
		
		if (doDefault) {
			var chartNavDiv = dojo.byId (this.namespace_ + "reportSelectorDiv");
			chartNavDiv.style.display = "";
		}
		
		console.log ("exit handleSavedPreferences");
	},
	setWebServiceSubmitValues: function () {
		if (this.connectionName_) {
			dojo.byId (this.namespace_ + "connectionNameH").value = this.connectionName_;
		}
		if (this.groupID_) {
			dojo.byId (this.namespace_ + "groupIDH").value = this.groupID_;
		}
		if (this.chartID_) {
			dojo.byId (this.namespace_ + "chartIDH").value = this.chartID_;
		}
	},
	handleWebServicePath: function (chartName) {
		var chartWidget = dijit.byId (this.namespace_ + "chartWidget");
		var errorHandler = { showMsg : true, callback: dojo.hitch (chartWidget, chartWidget.onError) };
	
		var kw = {
             content:   {
                         command: "getChartDefinition",
                         arg_datasource: encodeURI(this.connectionName_),
						 arg_groupID: encodeURI(this.groupID_),
						 arg_chartID: encodeURI(this.chartID_)
                        },
	         onExc: errorHandler,
             onResponse:{
                         callback: dojo.hitch(this, this.populateGetChartDefinitionCallback)
                        }
         };
         
         if ((chartName !== null) && (chartName !== undefined)) {
			kw.content.arg_chartName = encodeURI(chartName);
         }
	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
	},
	populateGetChartDefinitionCallback: function (data, ioArgs) {
		var clearPreferences = false;
		dijit.byId (this.namespace_ + "chartWidget").onReportSelection (
			data[0].chartSourceType, 
			data[0].connectionName, 
			this.groupID_,
			data[0].id,
			data[0].label,
			clearPreferences,
			false);
	},
	populateTCRPath: function () {
		 // TODO Implement this
	},
	populateWebServicePath: function () {
		this.showConnectionManager();
	},
	showChartNavigator: function () {
		// clear hidden parameters
		dojo.byId (this.namespace_ + "groupIDH").value = "";
		dojo.byId (this.namespace_ + "chartIDH").value = "";
		dojo.byId (this.namespace_ + "connectionNameH").value = "";
		dojo.byId (this.namespace_ + "descriptionH").value = "";	
		dojo.byId (this.namespace_ + "chartNameH").value = "";
	
		// show/hide divs
		dojo.byId (this.id + "chartSourceTypeDiv").style.display = "";
		
		dojo.byId (this.id + "tipServerDiv").style.display = "none";
		dojo.byId (this.id + "connectionMgrDiv").style.display = "none";
		dojo.byId (this.id + "mainChartSelectorDiv").style.display = "none";
		
		var chartNavDiv = dojo.byId (this.namespace_ + "reportSelectorDiv");
		chartNavDiv.style.display = "";
		
		this.setCurrentPage (this.CHART_SOURCE_TYPE_PAGE);
	},
	isNavigatorVisible: function () {
		return (
			(dojo.byId (this.id + "chartSourceTypeDiv").style.display === "") ||
			(dojo.byId (this.id + "tipServerDiv").style.display === "") ||
			(dojo.byId (this.id + "connectionMgrDiv").style.display === "") ||
			(dojo.byId (this.id + "mainChartSelectorDiv").style.display === "")
		);
	},
//	showConnectionManager: function () {
//		dojo.byId (this.id + "connectionMgrDiv").style.display = "";
//
//		dojo.byId (this.id + "chartSourceTypeDiv").style.display = "none";
//		dojo.byId (this.id + "tipServerDiv").style.display = "none";
//		dojo.byId (this.id + "mainChartSelectorDiv").style.display = "none";
//	},
	onCustomChartType: function () {
		dojo.byId(this.namespace_ + 'tipServer').checked=true;
		this.onChartSourceTypeSelection();
	},
	onImportChartType: function () {
		dojo.byId(this.namespace_ + 'tivoliApp').checked=true;
		this.onChartSourceTypeSelection();
	},
	onChartSourceTypeSelection: function () {
		var srcTypeDiv = dojo.byId (this.id + "chartSourceTypeDiv");

//		var tcrRadio = dojo.byId (this.id + "tcrRepository");
		var tipServerRadio = dojo.byId (this.namespace_ + "tipServer");
		var tivAppRadio = dojo.byId (this.namespace_ + "tivoliApp");
		
//		if (tcrRadio.checked) {
//			this.showTCRNavigator();
		if (tipServerRadio.checked) {
			srcTypeDiv.style.display = "none";
			this.setCurrentPage (this.CUSTOM_CHART_SELECTOR_PAGE);
			this.populateTipServerChartSelector();		
		} else if (tivAppRadio.checked) {
			srcTypeDiv.style.display = "none";
			this.showConnectionManager();
		}
	},
	getChartSourceType: function () {
//		var tcrRadio = dojo.byId (this.id + "tcrRepository");
		var tipServerRadio = dojo.byId (this.namespace_ + "tipServer");
		var tivAppRadio = dojo.byId (this.namespace_ + "tivoliApp");
	
//		if (tcrRadio.checked) {
//			return ("TivoliCommonReporting");
		if (tipServerRadio.checked) {
			return ("TIPServer");
		} else if (tivAppRadio.checked) {
			return ("WebService");
		} else {
			return (null);
		}
	},
	showTCRNavigator: function() {
		alert ("not implemented yet");
	},
	populateTipServerChartSelector: function (force) {
		var tipServerDiv = dojo.byId (this.id + "tipServerDiv");
		tipServerDiv.style.display = "";
		
	
		if (force || (dojo.byId (this.id + "tipServerChartSelector").options.length < 1)) {
	       var kw = {
                    content:   {
                                  command: "getReports"
                               },
                    onResponse:{
                                  callback: dojo.hitch(this, this.populateTipServerChartSelectorCallback)
                                }
                 };
			ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );
    	 }
	},
	/*******************************************************************************
	* This method will return a serialized object of all info inside the dialog form
	* You must not call this method while form is in use -- it will break dojo stuff!
	*******************************************************************************/
	getFormValuesForJSON: function(formID)
	{
		console.log ("Enter getFormValues for formID: " + formID);
	   var form = dijit.byId(formID);
	   return dojo.json.serialize(form.getValues()) ;	   	   
	},
	uploadChart: function () {
		console.log ("Enter uploadChart");
		var formID = this.id + "filenameForm";
		var filenameID = this.id + "filename";
		var filename = dojo.byId( filenameID );
		if (filename.value.length === 0 || filename.value === null) {
			// Do nothing, wait for user input
		} else {
 			dojo.io.iframe.send({
			  url: "/ibm/TIPChartPortlet/TIPChartController?command=uploadReport",
			  form: dojo.byId (formID),
		  	  handleAs: "json",
         	  error: dojo.hitch (this, this.handleError),
		  	  timeout: dojo.hitch (this, this.handleTimeout),
		   	  load: dojo.hitch (this, this.onUploadComplete)
		    });	
		    // TODO: remove this line once we upgrade to a dojo that has a fix for this.
		    // There is a bug in dojo 1.0 where the iframe becomes visible when you call
		    // send.
		    dojo.style(dojo.byId('dojoIoIframe'),"display","none"); 
		
		    this.uploadDialog.hide();
		}
	},
	handleError: function (response, ioArgs) {
//		console.error ("HTTP status code: ", ioArgs.xhr.status);
		console.error ("Error from server");
		console.error (response);
		console.error (ioArgs);
		return response;
	},
	
	handleTimeout: function (response, ioArgs) {
		console.error ("Timeout for request: " + ioArgs.xhr);
		return response;
	},
	
	onUploadComplete: function (data, ioArgs) {
		console.log ("data is: ");
		console.log (data);
		var modalWindow = null;
		var helper = new ibm.tivoli.tip.dojo.TIPHelper();
		
		if (data.id === null) {
			modalWindow = new ibm.tivoli.tip.dijit.TIPMessageDialog ( 
		                                          { 
			                                          type: "info",
													  portletTitle: helper.getPortletTitle(this.domNode),			                                          
	    	                                          message: this.messages_.TIPCH3008E,
	        	                                      messageId: "TIPCH3008E",
	            	                                  buttons: [ this.resources_.CLOSE ]
	                    	                        });
			modalWindow.show();
		} else {
			var chartSelector = dojo.byId (this.id + "tipServerChartSelector");
			var index = -1;
			if ((index = this.selectItemExists (chartSelector, data.id)) > -1) {
				// already exists so just select it
				chartSelector.options[index].selected = true;				
			} else {
				// doesn't exist so add it
				chartSelector.options[chartSelector.options.length] = new Option (data.label, data.id);
				chartSelector.options[chartSelector.options.length - 1].selected = true;
			}
		
			modalWindow = new ibm.tivoli.tip.dijit.TIPMessageDialog ( 
		                                          { 
			                                          type: "info",
													  portletTitle: helper.getPortletTitle(this.domNode),			                                          
	    	                                          message: this.messages_.TIPCH3003I,
	        	                                      messageId: "TIPCH3003I",
	            	                                  buttons: [ this.resources_.CLOSE ]
	                    	                        });
			modalWindow.show();
		}
	},
	selectItemExists: function (select, item) {
		for (var i=0; i<select.options.length; i++) {
			if (select.options[i].text == item) {
				return (i);
			}
		}
		
		return (-1);
	},
	populateTipServerChartSelectorCallback: function (data, ioArgs) {
		var chartSelector = dojo.byId (this.id + "tipServerChartSelector");
		var selected = false;
		chartSelector.options.length = 0;
		
		for (var i=0; i<data.length; i++) {
			chartSelector.options[chartSelector.options.length] = new Option (data[i].label, data[i].id);
			if (data[i].id == this.chartID_) {
				chartSelector.options[i].selected = true;
				selected = true;
			}
		}
		
		console.log ("chartSrcType: " + this.chartSrcType_);
		console.log ("chartID: "+ this.chartID_);
		if (selected) {
			this.onTipServerChartSelection(true);
		} else {
			if ((this.chartSrcType_ == "TIPServer") &&
				this.chartID_ && 
				(this.chartID_ !== "") && 
				(this.chartID_ !== "null")) {
				// This is the case where we have a predefined
				// chart but it has been deleted and no longer shows 
				// up in the list
				this.handleDeletedCustomChart();
			}
		}
	},
	handleDeletedCustomChart: function () {
		console.log ("enter handleDeletedCustomChart");
		this.chartID_ = null;
		this.showChartNavigator();
		console.log ("exit handleDeletedCustomChart");
	},
	onTipServerChartSelection: function (autoSelected) {
		var clearPreferences = true;
		var persist = true;
		if (autoSelected === true) {
			clearPreferences = false;
			persist = false;
		}
				
		var selector = dojo.byId (this.id + "tipServerChartSelector"); 
		var reportName = selector.options[selector.selectedIndex].text; 
		dojo.byId (this.namespace_ + "chartIDH").value = reportName;
		var chartSrcType = this.getChartSourceType();
		var groupID = null;
		var connectionName = null; //this.connectionMgr_ === null ? null : this.connectionMgr_.getSelectedDataSourceName();
		
		dijit.byId (this.namespace_ + "chartWidget").onReportSelection (
			chartSrcType,
			connectionName,
			groupID,
			reportName,
			reportName,
			clearPreferences,
			persist);		
	},
	refreshCustomCharts: function () {
		console.log ("enter refreshCustomCharts");
		this.populateTipServerChartSelector(true);
	},
	exportCustomChart: function () {
		var selector = dojo.byId (this.id + "tipServerChartSelector"); 
		var selected = selector.options[selector.selectedIndex];
		if (selected) {
			var chartID = selector.options[selector.selectedIndex].text; 
      // arg_chartID_UTF8 is the UTF-8 encoded string and
      // arg_chartID is the browser's default encoded string.
      var url = "/ibm/TIPChartPortlet/TIPChartController?command=exportChart&arg_chartID_UTF8="+ encodeURI(chartID).replace(/%/g, "%25")+"&arg_chartID="+chartID;

			window.open (url, 'ExportChart');
		}
	},
	deleteCustomChart: function () {
		var selector = dojo.byId (this.id + "tipServerChartSelector"); 
		var selected = selector.options[selector.selectedIndex];
		if (selected) {
			var reportName = selector.options[selector.selectedIndex].text; 

			var kw = {
             content:   {
                  command: "deleteChart",
                  arg_chartID: encodeURI(reportName),
                  arg_chartSrcType: this.getChartSourceType(),
                  arg_connectionName: null,
                  arg_groupID: null
                 },
            	 onResponse:{
                         callback: dojo.hitch(this, this.refreshCustomCharts)
       	                }
    	     };
	
	        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		} else {
			console.log ("In deleteCustomChart. No chart selected");
		}
	},
	showConnectionManager: function () {
		console.info ("enter showConnectionManager");
		//dojoType="ibm.tivoli.tip.dojo:ConnectionManagerWidget" namespace_="<portlet:namespace/>"
		var div = dojo.byId (this.id + "connectionMgrWidget");
		div.style.display = "";
		if (this.connectionMgr_ === null) {
			console.log ("creating connectionMgr_");
			this.connectionMgr_ = new ibm.tivoli.tip.charts.dijit.ConnectionManagerWidget (
				{
					namespace_:this.namespace_,
					callback_: dojo.hitch (this, this.onCMRealize)
				}, 
				div);
		} else {
			console.log ("this.connectionMgr_ already exists");
		}
	
		dojo.byId (this.id + "mainChartSelectorDiv").style.display = "none";
		dojo.byId (this.id + "connectionMgrDiv").style.display = "";
		this.setCurrentPage (this.CONNECTION_MGR_PAGE);
		
		console.log ("exit showConnectionManager");
	},
	onCMRealize: function () {
		if (this.connectionName_ && (this.connectionName_ !== null) && (this.connectionName_ !== "null")) {
			console.log ("In onCMRealize with connectionName_: " + this.connectionName_);
			this.connectionMgr_.selectConnection (this.connectionName_);
			this.showCMChartSelector();
		} else {
			console.log ("In onCMRealize with no connectionName: " + this.connectionName_);
		}
	},
	showCMChartSelector: function () {
		console.log ("Enter showCMChartSelector");
		if (this.connectionMgr_.getSelectedDataSourceName()) {
			var dataSourceName = this.connectionMgr_.getSelectedDataSourceName();
			console.log ("Using data source: " + dataSourceName);
			dojo.byId (this.namespace_ + "connectionNameH").value = dataSourceName;

			var chartSelector = dijit.byId (this.id + "chartSelectorDiv");
			if (chartSelector) {
				// chart selector already created, so don't create again
				// just set the data source
				chartSelector.setDataSource (dataSourceName);
			} else {			
				var div = dojo.byId (this.id + "chartSelectorDiv");
	
				chartSelector= new ibm.tivoli.tip.charts.dijit.ChartSelectorWidget (
					{
						datasource_:dataSourceName,
						namespace_:this.namespace_
						// TODO: Uncomment these to make auto selection work
//						groupID_:this.groupID_,
//						chartID_:this.chartID_
					},
					div);
			}
	
			dojo.byId (this.id + "connectionMgrDiv").style.display = "none";
			dojo.byId (this.id + "mainChartSelectorDiv").style.display = "";
			this.setCurrentPage (this.WS_CHART_SELECTOR_PAGE);
		} else {
			var helper = new ibm.tivoli.tip.dojo.TIPHelper();
    	    var modalWindow = new ibm.tivoli.tip.dijit.TIPMessageDialog (
		                                            { 
		                                              type: "error",
													  portletTitle: helper.getPortletTitle(this.domNode),			                                          
	    	                                          message: this.messages_.TIPCH3004E,
	        	                                      messageId: "TIPCH3004E",
	            	                                  buttons: [ this.resources_.CLOSE ]
	                    	                        });
			modalWindow.show();
		}
	},
	showConnectionEditor: function () {
	},
	showUploadDialog: function () {
		this.uploadDialog.show();
	},
	hideUploadDialog: function () {
		this.uploadDialog.hide();
	},
	resize: function (width, height) {
		if (this.getCurrentPage() == this.CONNECTION_MGR_PAGE) {
			this.connectionMgr_.resize(width, height);
		}
	},
	destroyDescendants: function(){
		// summary:
		//		Recursively destroy the children of this widget and their
		//		descendants.

		// TODO: should I destroy in the reverse order, to go bottom up?
		dojo.forEach(this.getDescendants(), function(widget){ 
			if (widget.id != this.id) { 
				console.log ("in ChartNavigator.destroyDescendants. about to destroy: ");
				console.log (widget);
				widget.destroy(); 
			}
		}, this);
	},
	destroy: function () {
		console.log ("enter ChartNavigator.destroy");
		dojo.forEach (this.topics, function (topic) {
			dojo.unsubscribe (topic);
		});
		dojo.forEach (this.connections, function (conn) {
			dojo.disconnect (conn);
		});
		dojo.forEach (this.tooltips, function (tt) {
			tt.destroy();
		});
		
		console.log ("calling ChartNavigator.inherited.destroy");
		this.inherited ("destroy", arguments);
		console.log ("exit ChartNavigator.destroy");
	}
});
