/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/

dojo.provide("ibm.tivoli.tip.charts.dijit.ChartWidget");
dojo.require("dojo.fx");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Tooltip");
dojo.require("dijit.Toolbar");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("dijit.form.Form");
dojo.require("dojo.io.iframe");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.form.ComboBox");
dojo.require("dijit.form.NumberSpinner");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartProperties");
dojo.require("ibm.tivoli.tip.charts.dijit.ParametersWidget");
dojo.require("ibm.tivoli.tip.charts.dijit.ConnectionManagerWidget");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartSelectorWidget");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartNavigator");
dojo.require("ibm.tivoli.tip.dojo.Global");
dojo.require("ibm.tivoli.tip.dojo.Server");
dojo.require("ibm.tivoli.tip.charts.dojo.Global");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");
dojo.require("ibm.tivoli.tip.dijit.TIPTable");
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenuV2");
dojo.require("ibm.tivoli.tip.dojo.TIPHelper");


// NLS
dojo.requireLocalization("ibm.tivoli.tip.charts.dijit", "chart_resources");
dojo.requireLocalization("ibm.tivoli.tip.charts.dijit", "chart_messages");

// define the widget class
dojo.declare(
	"ibm.tivoli.tip.charts.dijit.ChartWidget", 
    [ dijit._Widget, dijit._Templated ],
{
	namespace: "namespace1_",
	global: null,
	portletActionURL: null,
	iscPortletNamespace: "iscPortletNamespace1",
	contextPath: null,
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/ChartWidget.html"),
	widgetsInTemplate: true,
	tablesCreated: false,

  runReportStartTime: 0,
  runReportResponseTime: 5,
  updateMultiplier: 10,
  updateMinInterval: 30000,
  updateMaxInterval: 180000,
	chartSrcType_: null,
	connectionName_: null,
	groupID_: null,
	reportName: null,
	counter: 0,
	interval: null,
	oldChartType_: "line",
	oldParameterFragment_: "",
	paramWidget_: null,
	oldName_: null,
	oldDescription_: null,
	oldWidth_: null,
	oldHeight_: null,
	oldShowLegend_: null,
	oldChartRadio_: null,
	oldCheckForUpdates_: null,
	oldUpdateMultiplier_: null,
	oldReceiveContext_: null,
	oldChartSourceType_: null,
	oldShowNameInChart_: null,
	oldShowLastUpdated_: null,

	mssName_: null,
	prefsDialog: null,

	actualImgHeight_: null,
	actualImgWidth_: null,
	allowSubmit_: true,
	topics_: [],
	toggleSubscription: null,
	chartingTitle_: null,

	constructor: function() {
	//	dojo.byId (this.namespace + "console").innerHTML += "enter ChartWidget.constructor<br/>";
		console.log ("enter ChartWidget.constructor");
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.charts.dijit", "chart_resources");
	    this.messages_ = dojo.i18n.getLocalization("ibm.tivoli.tip.charts.dijit", "chart_messages");

		this.connections = [];
		this.tooltips = [];
		
		this.requestQueue = [];
		
		this.tipHelper_ = new ibm.tivoli.tip.dojo.TIPHelper();
		this.lastPage_ = null;
		this.lastPortletSize_ = null;
		
		this.firstRender = true;
		
		console.log ("exit ChartWidget.constructor");
	},

	postCreate: function() {
		this.inherited(arguments);
		console.log ("enter ChartWidget.postCreate");

		try {
			this.global = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace);
		    console.log ("got global: ");
		    console.log (this.global);

		    // store the original title so we can restore it if 
		    // the chart becomes unconfigured.  Because it comes
		    // from the server we don't have a client resource bundle
		    // so we must store it.
		    this.chartingTitle_ = this.tipHelper_.getPortletTitle (this.domNode);
		    console.log ("chartingTitle before change: " + this.chartingTitle_);

		    this.toolbarHidden_ = (this.global.mode == "view") ? true : false;
			this.mode = this.global.mode;

			this.initCounter();
			this.addButtonsToChartToolbar(this.toolbarDiv);
    
		    // subscribe to enter key press events for table
		    this.topics_.push (dojo.subscribe ("onEnter", this, "handleOnEnter"));
		    
		    // make context menu
		    this.makeChartContextMenu();

			// connect toggle event to nub
			this.connections.push (dojo.connect (this.nub, "onclick", this, "toggleToolbar"));
			this.connections.push (dojo.connect (this.nub, "onkeypress", this, "onNubKeyPress"));
			
			// Create dialog
			this.makeChartProperties();

			console.log ("exit ChartWidget.postCreate");
		} catch (ex) {
			console.error (ex);
		}
	},
	createOrUpdateTable: function (update) {
		console.info ("enter createOrUpdateTable");
		if (!this.tablesCreated) {
			this.createTIPTable(this.namespace + "tbl_tipChartData");
			this.tablesCreated = true;
		} else {
			if (update) {
		        this.updateTIPTable (this.namespace + "tbl_tipChartData");
		    }
	    }
	},
	createTIPTable: function(view) {
		var cmProvider = new ibm.tivoli.tip.dijit.CMSMenuProviderV2(
				{ global: this.global,
				  menuName: "",
				  hasLocalActions: false,
				  iscPortletNamespace: this.iscPortletNamespace
				});
	
		var tipTable = new ibm.tivoli.tip.dijit.TIPTable({
					global: this.global,
					tableID: view,
					cmProvider: cmProvider,
					width: "100%",
					open: !this.toolbarHidden_,
					makeDefaultButtons: false,
					id: view,
					autoSavePreferences : true
				},
				dojo.byId (view));
		tipTable.startup();
		this.addButtonsToTableToolbar (tipTable);

		// subscribe to table toolbar toggle, so we can also toggle the chart toolbar			
		this.toggleSubscription = dojo.subscribe (tipTable.id + "#ToggleToolbar", this, "toggleChartToolbar");
		this.topics_.push (dojo.subscribe (tipTable.id + "#LoadComplete", this, "onTableLoad"));
		
		this.resizeTable();
	},
	onTableLoad: function () {
		// We have to refresh to data again to accommodate a bug in TIPTable selection
//		dijit.byId (this.namespace + "tbl_tipChartData").onRefresh();
	},
	updateTIPTable: function(view) {
		var tbl = dijit.byId (view);
		tbl.onRefresh();
	},
	addButtonsToTableToolbar: function (table) {
		var tblToolbar = table.getToolbar();

		var ddMenu = new dijit.Menu ();
		var mi = new dijit.MenuItem ({
				label: this.resources_.REFRESH
			});
		mi.onClick = dojo.hitch (this, "refreshChart");
		ddMenu.addChild (mi);
		
		mi = new dijit.MenuItem ({
				label: this.resources_.RELOAD
			});
		mi.onClick = dojo.hitch (this, "reloadChart");
		ddMenu.addChild (mi);
		
		var button = new dijit.form.ComboButton (
			{	label: this.resources_.REFRESH,
				showLabel: false,
				iconClass: "refreshIcon",
				onClick: dojo.hitch (this, this.refreshChart),
				dropDown: ddMenu
			});
		tblToolbar.addChild (button);
		tblToolbar.addChild (new dijit.ToolbarSeparator());

		button = new ibm.tivoli.tip.dijit.TIPButton(
			{	id: this.id + "tblPreferences",
				iconClass: "propertiesIcon",
				label: this.resources_.PREFERENCES,
				showLabel: false,
			 	onClick: dojo.hitch (this, this.showPrefs) 
			});
		tblToolbar.addChild (button);
//		this.tooltips.push (new dijit.Tooltip({label:this.resources_.PREFERENCES, connectId:[this.id + "tblPreferences"]}, document.createElement("div")));

		// Only add toggle to chart if it is also a chart
	    var chartRadio = dijit.byId(this.namespace + "chartSelected");
		if (!chartRadio.disabled) {
			button = new ibm.tivoli.tip.dijit.TIPButton(
				{	id: this.id + "tblToggle", 
					iconClass: "chartGenericIcon",
					label: this.resources_.TOGGLE_TABLE_CHART,
					showLabel: false,
				 	onClick: dojo.hitch (this, this.toggleTableChart) 
				});
			tblToolbar.addChild (button);
		}
//		this.tooltips.push (new dijit.Tooltip({label:this.resources_.TOGGLE_TABLE_CHART, connectId:[this.id + "tblToggle"]}, document.createElement("div")));

		button = new ibm.tivoli.tip.dijit.TIPButton(
			{	id: this.id + "tblReturnToSelector", 
				iconClass: "backIcon",
				label: this.resources_.RETURN_TO_CHART_SELECTOR,
				showLabel: false,
			 	onClick: dojo.hitch (this, this.showChartSelector) 
			});
		tblToolbar.addChild (button);
//		this.tooltips.push (new dijit.Tooltip({label:this.resources_.RETURN_TO_CHART_SELECTOR, connectId:[this.id + "tblReturnToSelector"]}, document.createElement("div")));

		tblToolbar.addChild (new dijit.ToolbarSeparator());

		button = new ibm.tivoli.tip.dijit.TIPButton(
			{	id: this.id + "tblPrintPreview", 
				iconClass: "printPreviewIcon",
				label: this.resources_.PRINT_PREVIEW,				
				showLabel: false,
			 	onClick: dojo.hitch (this, this.printPreviewTable) 
			});
		tblToolbar.addChild (button);
//		this.tooltips.push (new dijit.Tooltip({label:this.resources_.PRINT_PREVIEW, connectId:[this.id + "tblPrintPreview"]}, document.createElement("div")));

		button = new ibm.tivoli.tip.dijit.TIPButton(
			{	id: this.id + "tblSaveAs", 
				iconClass: "saveToFileIcon",
				label: this.resources_.SAVE_AS_FILE,
				showLabel: false,
			 	onClick: dojo.hitch (this, this.saveTableAsFile) 
			});
		tblToolbar.addChild (button);
		
		
		ddMenu = new dijit.Menu ();
		
		var context = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace);
		if (context.roles.admin || context.roles.creator) {
			mi = new dijit.MenuItem ({
				label: this.resources_.SAVE_FOR_OTHERS
			});
			mi.onClick = dojo.hitch (this, "onSave");
			ddMenu.addChild (mi);
		
			mi = new dijit.MenuItem ({
				label: this.resources_.CLEAR_DEFAULT_PREFERENCES
			});
			mi.onClick = dojo.hitch (this, "onReset");
			ddMenu.addChild (mi);
		}
		
		mi = new dijit.MenuItem ({
				label: this.resources_.CLEAR_MY_PREFERENCES
			});
		mi.onClick = dojo.hitch (this, "onResetMyPreferences");
		ddMenu.addChild (mi);
		
		button = new dijit.form.DropDownButton (
			{	label: this.resources_.PUBLISH,
				showLabel: false,
				iconClass: "editIcon",
				dropDown: ddMenu
			});
		tblToolbar.addChild (button);
//		this.tooltips.push (new dijit.Tooltip({label:this.resources_.SAVE_AS_FILE, connectId:[this.id + "tblSaveAs"]}, document.createElement("div")));
	},
	addButtonsToChartToolbar: function (toolbar) {
		var ddMenu = new dijit.Menu ();
		var mi = new dijit.MenuItem ({
				label: this.resources_.REFRESH
			});
		mi.onClick = dojo.hitch (this, "refreshChart");
		ddMenu.addChild (mi);
		
		mi = new dijit.MenuItem ({
				label: this.resources_.RELOAD
			});
		mi.onClick = dojo.hitch (this, "reloadChart");
		ddMenu.addChild (mi);
		
		var button = new dijit.form.ComboButton (
			{	label: this.resources_.REFRESH,
				showLabel: false,
				iconClass: "refreshIcon",
				onClick: dojo.hitch (this, this.refreshChart),
				dropDown: ddMenu
			});
		toolbar.addChild (button);
		toolbar.addChild (new dijit.ToolbarSeparator());

		button = new ibm.tivoli.tip.dijit.TIPButton(
			{	id: this.namespace + "prefButton",
				iconClass: "propertiesIcon",
				label: this.resources_.PREFERENCES,
				showLabel: false,
			 	onClick: dojo.hitch (this, this.showPrefs) 
			});
		toolbar.addChild (button);

		button = new ibm.tivoli.tip.dijit.TIPButton(
				{	id: this.namespace + "toggleButton", 
					iconClass: "tableIcon",
					label: this.resources_.TOGGLE_TABLE_CHART,
					showLabel: false,
				 	onClick: dojo.hitch (this, this.toggleTableChart) 
				});
		toolbar.addChild (button);

		button = new ibm.tivoli.tip.dijit.TIPButton(
			{	id: this.namespace + "returnButton", 
				iconClass: "backIcon",
				label: this.resources_.RETURN_TO_CHART_SELECTOR,
				showLabel: false,
			 	onClick: dojo.hitch (this, this.showChartSelector) 
			});
		toolbar.addChild (button);

		toolbar.addChild (new dijit.ToolbarSeparator());

		button = new ibm.tivoli.tip.dijit.TIPButton(
			{	id: this.namespace + "printPreviewChartButton", 
				iconClass: "printPreviewIcon",
				label: this.resources_.PRINT_PREVIEW,				
				showLabel: false,
			 	onClick: dojo.hitch (this, this.printPreviewChart) 
			});
		toolbar.addChild (button);

		button = new ibm.tivoli.tip.dijit.TIPButton(
			{	id: this.id + "saveChartAsFileButton", 
				iconClass: "saveChartIcon",
				label: this.resources_.SAVE_AS_FILE,
				showLabel: false,
			 	onClick: dojo.hitch (this, this.saveChartAsFile) 
			});
		toolbar.addChild (button);
		
		
		ddMenu = new dijit.Menu ();
		
		var context = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace);
		if (context.roles.admin || context.roles.creator) {
			mi = new dijit.MenuItem ({
				label: this.resources_.SAVE_FOR_OTHERS
			});
			mi.onClick = dojo.hitch (this, "onSave");
			ddMenu.addChild (mi);
		
			mi = new dijit.MenuItem ({
				label: this.resources_.CLEAR_DEFAULT_PREFERENCES
			});
			mi.onClick = dojo.hitch (this, "onReset");
			ddMenu.addChild (mi);
		}
		
		mi = new dijit.MenuItem ({
				label: this.resources_.CLEAR_MY_PREFERENCES
			});
		mi.onClick = dojo.hitch (this, "onResetMyPreferences");
		ddMenu.addChild (mi);
		
		button = new dijit.form.DropDownButton (
			{	label: this.resources_.PUBLISH,
				showLabel: false,
				iconClass: "editIcon",
				dropDown: ddMenu
			});
		toolbar.addChild (button);
	},
	toggleTableChart: function() {
	    var tableRadio = dijit.byId(this.namespace + "tableSelected");
	    var chartRadio = dijit.byId(this.namespace + "chartSelected");
		var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");

	    if (tableRadio.checked) {
    	  	tableRadio.setChecked (false);
	       	chartRadio.setChecked (true);
			// Hide table
	        this.tableDiv.style.display = "none";
	        // Show chart toolbar
       		if (!this.toolbarHidden_) {
		        this.toolbarDiv.domNode.style.display = "";
		    }
			// Show chart
			this.chartDiv.style.display = "";
			chartNavigator.setCurrentPage (chartNavigator.CHART_PAGE);
	    } else {
	       	tableRadio.setChecked (true);
	       	chartRadio.setChecked (false);
			// Show table
	        this.tableDiv.style.display = "";
			// Hide chart
			this.chartDiv.style.display = "none";
	        // Hide chart toolbar
	        this.toolbarDiv.domNode.style.display = "none";
			chartNavigator.setCurrentPage (chartNavigator.TABLE_PAGE);
			this.createOrUpdateTable(false);
		}
		
		this.saveUserPrefs();
	},
	showChartSelector: function () {
    if (this.interval !== null) {
      // if auto update is on, cancel it
			clearTimeout (this.interval);
			this.interval = null;
		}
		this.onResetMyPreferences(false);
		var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");
		chartNavigator.setCurrentPage (chartNavigator.CHART_SOURCE_TYPE_PAGE);
		
		this.clearWidthHeight();
	
		this.chartDiv.style.display = "none";
		this.tableDiv.style.display = "none";

		this.cleanupForChartChange();
			
		var tbl2 = document.createElement("table");
		tbl2.setAttribute ("id", this.namespace + "tbl_tipChartData");
		tbl2.setAttribute ("class", "tipTable");
		this.tableDiv.appendChild (tbl2);
		
		dojo.style (this.metaDiv, "display", "none");
		if (!chartNavigator.isNavigatorVisible()) {
			chartNavigator.showChartNavigator();
		}
		
		this.reportSelectorDiv.style.display = "";
	
		this.handleNotPrimedWebService();
	},
	cleanupForChartChange: function () {
		// remove parametersDiv
		var paramDiv = dijit.byId (this.namespace + "parametersDiv");
		if (paramDiv) {
			paramDiv.destroy();
		}
	
		// remove old table
		this.destroyTable();
				
		// restore portlet title to translated Charting
		this.tipHelper_.setPortletTitle (this.domNode, this.chartingTitle_);
		this.global.setPortletTitle (this.tipHelper_.getPortletTitle (this.domNode));
	},
	destroyTable: function () {
		// remove old table
		var tbl = dijit.byId (this.namespace + "tbl_tipChartData");
		if (tbl) {
			// remove from DOM
			this.tableDiv.removeChild (dojo.byId (this.namespace + "tbl_tipChartData"));

			console.log ("dijit.registry: ");
			console.log (dijit.registry);
			// remove from dijit registry
			tbl.destroyRecursive();
		}
	},
	handleNotPrimedWebService: function () {
		var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");
		if ((chartNavigator.getChartSourceType() == "WebService") &&
			(chartNavigator.connectionMgr_ === null)) {
			chartNavigator.showChartNavigator();
		}
	},
	printPreviewTable: function () {
		var view = this.namespace + "tbl_tipChartData";
		var nameField = dojo.byId(this.namespace + "chartName");
		var name = encodeURI(nameField.value);
		
		var url = "/ibm/TIPChartPortlet/TIPChartController?command=printTable&arg_view="+view+"&print=true&arg_portletNamespace=" + this.namespace + "&arg_name=" + name;

		window.open (url, 'TIPChartPrintPreview');
	},
	saveTableAsFile: function () {
		var view = this.namespace + "tbl_tipChartData";
		var nameField = dojo.byId(this.namespace + "chartName");
		var name = encodeURI(nameField.value);
		var url = "/ibm/TIPChartPortlet/TIPChartController?command=printTable&arg_view="+view+"&arg_portletNamespace=" + this.namespace + "&arg_name=" + name;

		window.open (url, 'TIPChartPrintPreview');
	},
	printPreviewChart: function () {
		var url = "/ibm/TIPChartPortlet/TIPChartController?command=getChart&arg_portletNamespace=" + this.namespace + "&print=true";

		window.open (url, 'TIPChartPrintPreview');
	},
	saveChartAsFile: function () {
		var url = "/ibm/TIPChartPortlet/TIPChartController?command=getChart&arg_portletNamespace=" + this.namespace;

		window.open (url, 'TIPChartPrintPreview');
	},
	onNubKeyPress: function (event) {
	  	if (event.keyCode == 13) {
		  	event.cancelBubble = true;
	  		event.returnValue = false;
	  		console.log ("in onNubKeyPress: pressed enter");
	  		this.toggleToolbar();
	  	}
	},
	toggleToolbar: function () {
		this.toggleTableToolbar();
		this.toggleChartToolbar();
	},
	toggleTableToolbar: function () {
		console.log ("enter toggle table toolbar");
		
		var tipTable = dijit.byId (this.namespace + "tbl_tipChartData");
		if (tipTable) {
			dojo.unsubscribe (this.toggleSubscription);
			this.toggleSubscription = null;
			tipTable.toggleToolbar();	
			// subscribe to table toolbar toggle, so we can also toggle the chart toolbar			
			this.toggleSubscription = dojo.subscribe (tipTable.id + "#ToggleToolbar", this, "toggleChartToolbar");
		}
	},
	toggleChartToolbar: function () {
		console.log ("enter toggle toolbar. existing state: " + this.toolbarHidden_);
		if (this.toolbarHidden_) {
			this.openChartToolbar();
		} else {
			this.closeChartToolbar();
		}
	},
	openChartToolbar: function () {
		this.toolbarHidden_ = false;
		console.log ("showing toolbar");
		this.animateToolbarOpen();
		dojo.addClass (this.nub, "nubOpen");
		dojo.removeClass (this.nub, "nubClosed");
	},
	closeChartToolbar: function () {
		this.toolbarHidden_ = true;
		console.log ("hiding toolbar");
		this.animateToolbarClose();
		dojo.addClass (this.nub, "nubClosed");
		dojo.removeClass (this.nub, "nubOpen");
	},
	animateToolbarOpen: function () {
		dojo.fx.wipeIn ({
				node: dojo.byId (this.namespace + "toolbarDiv"),
		        duration: 500,
                onEnd: dojo.hitch(this, function() {
                })
			}).play();
	},
	animateToolbarClose: function () {
		dojo.fx.wipeOut ({
				node: dojo.byId (this.namespace + "toolbarDiv"),
		        duration: 500,
                onEnd: dojo.hitch(this, function() {
                })
			}).play();
	},
	dlgOKCallback: function () {
		var ct = dojo.byId(this.namespace + "chartType");
		var tableRadio = dijit.byId(this.namespace + "tableSelected");
		var chartRadio = dijit.byId(this.namespace + "chartSelected");
        var showTable = dijit.byId(this.namespace + "showTableCB");
		var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");

        if (tableRadio.checked) {
			// Show table
            this.tableDiv.style.display = "";
			// Hide chart
			this.chartDiv.style.display = "none";
			// Set the current page
			chartNavigator.setCurrentPage (chartNavigator.TABLE_PAGE);
			// Update table
//            this.createOrUpdateTable (true);
        } else {
			// Hide table
            this.tableDiv.style.display = "none";
			// Show chart
			this.chartDiv.style.display = "";
			// Set the current page
			chartNavigator.setCurrentPage (chartNavigator.TABLE_PAGE);
        }
            
		if (this.propertiesChanged()) {
          	this.updateProperties(true);
        } 
            
//	    this.configAutoUpdate();
	},
	propertiesChanged: function () {
		console.log ("enter propertiesChanged");
		var nameField = dojo.byId(this.namespace + "chartName");
		var descriptionField = dijit.byId(this.namespace + "description");
		var heightField = dojo.byId(this.namespace + "height");
		var widthField = dojo.byId (this.namespace + "width");
		var showLegendField = dijit.byId (this.namespace + "showLegendCB");
	    var chartRadio = dojo.byId(this.namespace + "chartSelected");
		var checkForUpdatesCB = dijit.byId (this.namespace + "checkForUpdatesCB");
		var receiveContextRadio = dijit.byId(this.namespace + "contextualParametersSelected");
		var chartTypeSelector = dijit.byId(this.namespace + "mainChartNavigatorDiv");
		var showNameInChart = dijit.byId (this.namespace + "showNameInChart");
		var showLastUpdated = dijit.byId (this.namespace + "showLastUpdated");
	
		var paramFragment = this.getParametersAsURLFragment();
	
		var result = (nameField.value != this.oldName_) ||
				(heightField.value != this.oldHeight_) ||
				(widthField.value != this.oldWidth_) ||
				(showLegendField.checked != this.oldShowLegend_) ||
				(descriptionField.getValue() != this.oldDescription_) ||
				(chartRadio.checked != this.oldChartRadio_) ||
				(checkForUpdatesCB.checked != this.oldCheckForUpdates_) ||
				(receiveContextRadio.checked != this.oldReceiveContext_) ||
				(chartTypeSelector.getChartSourceType() != this.oldChartSourceType_) ||
				(showNameInChart.checked != this.oldShowNameInChart_) ||
				(showLastUpdated.checked != this.oldShowLastUpdated_) ||
				(this.oldParameterFragment_ != paramFragment);
		console.log ("exit propertiesChanged: " + result);			
	
		return (result);
	},
	updateProperties: function (persist) {
		console.log ("enter updateProperties");
		var shouldRunReport = this.shouldRunReport();

		var nameField = dojo.byId(this.namespace + "chartName");
		var descriptionField = dijit.byId(this.namespace + "description");
		var showLegendField = dijit.byId (this.namespace + "showLegendCB");
	    var tableRadio = dijit.byId(this.namespace + "tableSelected");
	    var chartRadio = dijit.byId(this.namespace + "chartSelected");
		var checkForUpdatesCB = dijit.byId (this.namespace + "checkForUpdatesCB");
		var receiveContextRadio = dijit.byId(this.namespace + "contextualParametersSelected");
		var useDefaultContextRadio = dijit.byId(this.namespace + "defaultParametersSelected");
		var chartNavigator = dijit.byId(this.namespace + "mainChartNavigatorDiv");
		var showNameInChart = dijit.byId (this.namespace + "showNameInChart");
		var showLastUpdated = dijit.byId (this.namespace + "showLastUpdated");
	
		var urlFrag = {};

		if (nameField.value != this.oldName_) {
			urlFrag.arg_newName = encodeURI(nameField.value);
			dojo.byId(this.namespace + "chartNameH").value = nameField.value;
			this.oldName_ = nameField.value;
		}
		if (descriptionField.getValue() != this.oldDescription_) {
			urlFrag.arg_description = encodeURI(descriptionField.getValue());
			dojo.byId(this.namespace + "descriptionH").value = descriptionField.getValue();
			this.oldDescription_ = descriptionField.getValue();
		}
		if (showLegendField.checked != this.oldShowLegend_) {
			urlFrag.arg_showLegend = showLegendField.checked;
			this.oldShowLegend_ = showLegendField.checked;
		}
		if (tableRadio.checked) {
			urlFrag.arg_viewType = "table";
			this.oldChartRadio_ = false;
		} else if (chartRadio.checked) {
			urlFrag.arg_viewType = "chart";
			this.oldChartRadio_ = true;
		}
	
		console.log ("checkForUpdatesCB: ");
		console.log (checkForUpdatesCB);
		
		if (checkForUpdatesCB.checked != this.oldCheckForUpdates_) {
			urlFrag.arg_autoUpdateActive = checkForUpdatesCB.checked;
			this.oldCheckForUpdates_ = checkForUpdatesCB.checked;
		}
		
		if (showNameInChart.checked != this.oldShowNameInChart_) {
			urlFrag.arg_showNameInChart = showNameInChart.checked;
			this.oldShowNameInChart_ = showNameInChart.checked;
		}
		
		if (showLastUpdated.checked != this.oldShowLastUpdated_) {
			urlFrag.arg_showLastUpdated = showLastUpdated.checked;
			this.oldShowLastUpdated_ = showLastUpdated.checked;
		}
	
		if (receiveContextRadio.checked != this.oldReceiveContext_) {
			this.oldReceiveContext_ = receiveContextRadio.checked;
		}
		
		if (chartNavigator.getChartSourceType() != this.oldChartSourceType_) {
			this.oldChartSourceType_ = chartNavigator.getChartSourceType();
		}
	
		urlFrag.arg_chartSourceType = chartNavigator.getChartSourceType();
		urlFrag.arg_receiveContextActive = receiveContextRadio.checked;

		var paramFragment = this.getParametersAsURLFragment();
		this.oldParameterFragment_ = paramFragment;

		urlFrag.command = "modifyReport";
		urlFrag.arg_portletNamespace = this.namespace;
		urlFrag.arg_reportName = encodeURI(this.reportName);
		urlFrag.arg_chartSrcType = this.chartSrcType_;
		urlFrag.arg_connectionName = encodeURI(this.connectionName_);
		urlFrag.arg_groupID = this.groupID_;
		urlFrag.arg_dataSource = encodeURI(this.connectionName_);
		urlFrag.arg_chartID = encodeURI(this.reportName);
		urlFrag.arg_persist = persist;
		var size = this.getChartSize();
		urlFrag.arg_width = size.available.w;
		urlFrag.arg_height = size.available.h;
//		this.clearWidthHeight();
		
		var params = this.getParametersAsJSObject();
		for (var i in params) {
			if (i) {
				urlFrag[i] = params[i];
			}
		}
		
		// Update the internal data store used by parameters widget with the latest 
		// values from the text boxes
		dijit.byId (this.namespace + "parametersDiv").updateInternalParametersData();
	
		var handler = null;
	
	    if (shouldRunReport) {
			urlFrag.shouldRunReport = "true";
			handler = dojo.hitch (this, this.runReportCallback);
		}

		var kw = {
             content: urlFrag,
           	 onResponse:{
                      callback: handler
   	                }
   	     };

		this.makeRequestPrimitive (kw);
                    
		this.setVisibilityPostRunReport ();                    
	},
	shouldRunReport: function () {
		console.log ("enter shouldRunReport");
		var nameField = dojo.byId(this.namespace + "chartName");
		var descriptionField = dijit.byId(this.namespace + "description");
		var heightField = dojo.byId(this.namespace + "height");
		var widthField = dojo.byId (this.namespace + "width");
		var showLegendField = dijit.byId (this.namespace + "showLegendCB");
		var showNameInChart = dijit.byId (this.namespace + "showNameInChart");
	
		var serverPropsChanged = (nameField.value != this.oldName_) ||
				(heightField.value != this.oldHeight_) ||
				(widthField.value != this.oldWidth_) ||
				(showNameInChart.checked != this.oldShowNameInChart_) ||
				(showLegendField.checked != this.oldShowLegend_) ||
				(descriptionField.getValue() != this.oldDescription_);

		var result = (this.updateMultiplier > 1) ||
           	(this.getParametersAsURLFragment() != this.oldParameterFragment_) ||
           	serverPropsChanged;
           	
	    console.log ("exit shouldRunReport: " + result);
	    return (result);
	},
	dlgOKPressed: function() {
	    var ds = dojo.byId(this.namespace + "dataSource");
	    var ct = dojo.byId(this.namespace + "chartType");
		var checkForUpdates = dijit.byId(this.namespace + "checkForUpdatesCB");

		if (checkForUpdates.checked) {
            
			if (this.interval !== null) {
				clearTimeout (this.interval);
				this.interval = null;
			}
		} else {
			if (this.interval !== null) {
				clearTimeout (this.interval);
				this.interval = null;
			}
		}

	    // Close dialog
	    var prefsDialog = dijit.byId(this.namespace + "prefs_dialog");
	    prefsDialog.hide();
	    this.dlgOKCallback();
	},
	showImage: function () {
		var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");
		chartNavigator.setCurrentPage (chartNavigator.CHART_PAGE);
	
		if (this.chartImage.src) {
			this.animateChartChange();
		} else {
			// just load the image
			this.chartImage.src = '/ibm/TIPChartPortlet/TIPChartController?command=getChart&arg_portletNamespace=' + this.namespace + '&arg_count=' + this.counter;
		}
	},
	animateChartChange: function () {
		dojo.fx.chain([ 
	       dojo.fadeOut({ 
	       	   node: this.namespace + 'chartImage', 
	       	   duration: 300,
               onEnd: dojo.hitch(this, function() {
                   // load the new image
					if (this.actualImgWidth_ && this.actualImgHeight_) {
						this.chartImage.width = this.actualImgWidth_;
						this.chartImage.height = this.actualImgHeight_;
						this.chartImage.src = '/ibm/TIPChartPortlet/TIPChartController?command=getChart&arg_portletNamespace=' + this.namespace + '&arg_count=' + this.counter;
					} else {
						this.chartImage.src = '/ibm/TIPChartPortlet/TIPChartController?command=getChart&arg_portletNamespace=' + this.namespace + '&arg_count=' + this.counter;
					}
				})
			}),
	 	    dojo.fadeIn({ 
	 	   		node: this.namespace + 'chartImage', 
	 	   		duration: 300,
	 	   		onEnd: dojo.hitch (this, function () {
					// do nothing for now
	 	   		})
	 	    })
		]).play();	
	},
	setMap: function (data) {
	    var mapDiv = dojo.byId (this.namespace + "mapDiv");
		var html = '<map name="chartmap"> ' + data.map + ' </map>';
	  	mapDiv.innerHTML = html;
	},
	loadImage: function () {
		// load the new image
		var newImage = new Image();
		this.counter++;
		newImage.src = '/ibm/TIPChartPortlet/TIPChartController?command=getChart&arg_portletNamespace=' + this.namespace + '&arg_count=' + this.counter;
	// wait 250 ms... this should give the image time to load, then update the DOM to display it
	//	setTimeout(<portlet:namespace/>showImage, 250);
		this.showImage();
	},
	runLatestReport: function () {
		this.runReport(
				this.chartSrcType_,
				this.connectionName_,
				this.groupID_,
				this.reportName,
				false,
				false,
				false,    
				false);   // show processing indicator
	},
	configAutoUpdate: function () {
		console.log ("enter configAutoUpdate: updateMultiplier: " + this.updateMultiplier + 
			", interval: " + this.interval + 
			", and checkForUpdates: " + dijit.byId (this.namespace + "checkForUpdatesCB").checked);
		
		if ((this.interval === null) && (this.updateMultiplier > 0) &&
			dijit.byId (this.namespace + "checkForUpdatesCB").checked) {
			// equivalent of sleep, then run function
//    	    var fnc = 'this.runReport("' + this.chartSrcType_ + '", "' + this.connectionName_ + '", "' + this.groupID_ + '", "' + this.reportName +'")';
			var fnc = dojo.hitch (this, this.runLatestReport);
		    var nextUpdate = this.getUpdateInterval();
		    this.interval = setTimeout(fnc, nextUpdate);
		} else {
            if ((this.interval !== null) && (!dijit.byId (this.namespace + "checkForUpdatesCB").checked)) {
                clearTimeout (this.interval);
                this.interval = null;
            }
		}
		console.log ("exit configAutoUpdate");
	},
  getUpdateInterval: function() {
      var nextUpdateInterval = this.runReportResponseTime * this.updateMultiplier;
console.log("responsetime="+(this.runReportResponseTime/1000)+"s next update="+(nextUpdateInterval/1000)+"s  update minimum interval="+(this.updateMinInterval/1000)+"s update maximum interval="+(this.updateMaxInterval/1000)+"s");
      if ( nextUpdateInterval > this.updateMaxInterval ) {
        nextUpdateInterval = this.updateMaxInterval;
      } else if ( nextUpdateInterval < this.updateMinInterval ) {
        nextUpdateInterval = this.updateMinInterval;
      }
      return nextUpdateInterval;
  },
	runReportCallback: function (data, ioArgs) {
		console.log ("Enter runReportCallback with data");
		console.log (data);
		// get the time taken to run report
		this.runReportResponseTime = new Date().getTime() - this.runReportStartTime;
		try {
		this.reportSelectorDiv.style.display = "none";
		
	   	if (data.chartRendered.toString().toLowerCase() == "true") {
   			console.log ("chartRendered true");
	   		this.setMap(data);
	   		this.loadImage();
   			this.showChartAndTable();
	   	} else {
	   		console.log ("chartRendered false");
	   		this.showTableOnly();
	   	}
		   	
		this.updateMetaData();
			
	    var chartDiv = dojo.byId(this.namespace + "chartDiv");
	    var tableDiv = dojo.byId(this.namespace + "tableDiv");
	    var tableRadio = dijit.byId(this.namespace + "tableSelected");
    
	    if (tableRadio.checked) {
			// Show table
	        tableDiv.style.display = "";
			// Hide chart
			chartDiv.style.display = "none";
	    } else {
			// Hide table
	        tableDiv.style.display = "none";
			// Show chart
			chartDiv.style.display = "";
		}
		
		// Clear the old timeout so we can start the new one.
		if (this.interval !== null) {
			clearTimeout (this.interval);
			this.interval = null;
		}
		
		console.log ("ChartWidget.runReportCallback: requestQueue length before removing current request: " + this.requestQueue.length);
		if (this.requestQueue.length == 1) {
			console.log ("ChartWidget.runReportCallback: removing current request. no more requests to handle");
			// this was the only request in the queue, so remove it
			this.requestQueue.shift();
			// check to see if auto update should be turned back on
			this.configAutoUpdate();
		} else if (this.requestQueue.length < 1) {
			console.log ("ChartWidget.runReportCallback: queue length is less than 1... nothing to remove or process");
			// this shouldn't happen, but if nothing is in the queue, 
			// we should check to see if auto update needs to be re-enabled.
			this.configAutoUpdate();
		} else {  // length > 1
			console.log ("ChartWidget.runReportCallback: queue length is greater than 1... removing current request and processing next request");
			// pop off the most recent request which was just run
			this.requestQueue.shift();
			// now get the current request to invoke
			var requestContext = this.requestQueue.shift();
			ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( requestContext );			
		}

		} catch (ex) {
			console.error ("Caught javascript exception in runReportCallback");
			console.error (ex);
		}
	},
	updateMetaData: function () {
		var lastUpdated = new Date();
		var msg = dojo.string.substitute(this.resources_.LAST_UPDATED, { 0: lastUpdated.toLocaleString() });
		this.metaDiv.innerHTML = "<p class=\"lastUpdated\">" + msg + "</p>";
	},
	getParametersAsJSObject: function () {
		var params = {};

		if (this.paramWidget_ !== null) {
			var model = this.paramWidget_.getParameters();
			var param = null;
			var value = null;
		
			for (var row in model) {
				if (row) {
					param = model[row];
					value = this.paramWidget_.getParameterValue(param.name);
			
					if ((value !== null) && (value !== "")) {
						params["param_" + param.name] = encodeURI (value);
					}
				}
			}
		}

	//	alert ("urlFragment: " + urlFragment);
		console.log ("paramsAsJSObject: ");	
		console.log (params);
		return (params);
	},
	getParametersAsURLFragment: function () {
		var urlFragment = "";

		if (this.paramWidget_ !== null) {
			var model = this.paramWidget_.getParameters();
			var param = null;
			var value = null;
		
			for (var row in model) {
				if (row) {
					param = model[row];
					value = this.paramWidget_.getParameterValue(param.name);
			
					if ((value !== null) && (value !== "")) {
						if (urlFragment !== "") {
							urlFragment += "&";
						}
						urlFragment += "param_";
						urlFragment += param.name;
						urlFragment += "=";
						urlFragment += value;
					}
				}
			}
		}

	//	alert ("urlFragment: " + urlFragment);
		console.log ("urlFragment: " + urlFragment);	
		return (urlFragment);
	},
	refreshChart: function () {
		this.runReport (this.chartSrcType_, this.connectionName_, this.groupID_, this.reportName, false, false, false);	
	},
	reloadChart: function () {
	    // Pass along another param to tell runReport to grab new one
  		this.runReport (this.chartSrcType_, this.connectionName_, this.groupID_, this.reportName, false, true, false);	
	},

	clearWidthHeight: function () {
		console.log ("clearing image width and height");
		this.actualImgHeight_ = null;
		this.actualImgWidth_ = null;
		dijit.registry.remove (this.namespace + "chartImage");
		delete this.chartImage;
		dojo.byId (this.id + "chartImageDiv").innerHTML = '<a class="imagemap">' +
					'<img id="' + this.namespace + 'chartImage" dojoAttachPoint="chartImage" border="0" ISMAP USEMAP="#chartmap" /> ' +
					'</a>';
		this.chartImage = dojo.byId (this.namespace + 'chartImage');
//		this.chartDiv.innerHTML = '';
	},
	saveWidthHeight: function () {
		var img = dojo.byId (this.namespace + "chartImage");
		if (img) {
			console.log ("setting image height: " + img.height + " and width: " + img.width);
			this.actualImgHeight_ = img.height;
			this.actualImgWidth_ = img.width;
		} else {
			console.log ("no existing image for height & width");
		}
	},
	runReport: function (chartSrcType, connectionName, groupID, report, clearPreferences, reloadChart, persist, showProcessing) {
		console.log ("enter ChartWidget.runReport");
		this.saveWidthHeight ();
		this.reportName = report;
		this.chartSrcType_ = chartSrcType;
		this.connectionName_ = connectionName;
		this.groupID_ = groupID;
		
		var urlFragment = "";
		var content = {};
		
		if (!clearPreferences) {
			try { 
				urlFragment = this.getParametersAsURLFragment();
				content = this.getParametersAsJSObject();
			} catch (e) {
				// eat
			}
		}
		
		this.oldParameterFragment_ = urlFragment;
		
		content.command = "modifyReport";
		var size = this.getChartSize();
		content.arg_width = size.available.w;
		content.arg_height = size.available.h;		
		
		content.arg_portletNamespace = this.namespace;
		content.arg_reportName = encodeURI(report);
		content.arg_chartSrcType = chartSrcType;
		content.arg_connectionName = encodeURI(connectionName);
		content.arg_datasource = encodeURI(connectionName);
		content.arg_chartID = encodeURI(report);
		content.arg_groupID = encodeURI(groupID);
		content.shouldRunReport = true;
		
		if (clearPreferences) {
			content.clearPreferences="true";
		} 
		if (reloadChart) {
			content.reloadChart="true";
		}
		if (persist) {
			content.arg_persist = "true";
		}

		var errorHandler = { showMsg : true, callback: dojo.hitch (this, this.onError) };

		var kw = {
			showBusyDialog: showProcessing,
             content: content,
             onExc: errorHandler,
           	 onResponse:{
                      callback: dojo.hitch (this, this.runReportCallback)
   	                }
   	     };

		this.makeRequestPrimitive (kw);
		
		this.setVisibilityPostRunReport ();
		console.log ("exit ChartWidget.runReport");
	},
	setVisibilityPostRunReport: function () {
		// set the chart name in case it changed
		var nameField = dojo.byId(this.namespace + "chartName");
		if ((nameField.value !== undefined) && (nameField.value !== "")) {
			this.tipHelper_.setPortletTitle (this.domNode, nameField.value);
			this.global.setPortletTitle (this.tipHelper_.getPortletTitle (this.domNode));
		}
		
		if (this.toolbarHidden_) {
			dojo.byId (this.namespace + "toolbarDiv").style.display = "none";
		} else {
			dojo.byId (this.namespace + "toolbarDiv").style.display = "";
		}
	
		if (dijit.byId (this.namespace + "showLastUpdated").checked) {
			dojo.style (this.metaDiv, "display", "");
		} else {
			dojo.style (this.metaDiv, "display", "none");
		}
	},
	onReportSelection: function (chartSrcType, connectionName, groupID, chartID, chartName, clearPreferences, persist) {
		this.tablesCreated = false;
		this.oldName_ = chartName;
		this.reportName = chartID;
		this.chartSrcType_ = chartSrcType;
		this.connectionName_ = connectionName;
		this.groupID_ = groupID;
	
	    this.getChartInfo(chartSrcType, connectionName, groupID, chartID, chartName, persist);
		this.runReport (chartSrcType, connectionName, groupID, chartID, clearPreferences, false, persist);
	},
	createParamWidget: function (reportName) {
	//	var data = [{"helpText":"Hello World","displayName":"Hostname","name":"Hostname","type":"0","promptText":"Enter a hostname"}];
				var kw = {
	             content:   {
                        command: "readParameters",
                        arg_portletNamespace: this.namespace,
                        arg_reportName: encodeURI(reportName),
                        arg_chartSrcType: this.chartSrcType_,
                        arg_connectionName: encodeURI(this.connectionName_),
                        arg_groupID: encodeURI(this.groupID_)
                        },
            	 onResponse:{
                         callback: dojo.hitch(this, this.createParamWidgetCallback)
       	                }
    	     };
	
	        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
	},
	createParamWidgetCallback: function (data, ioArgs) {
		// remove existing parametersDiv
		var paramDiv = dijit.byId (this.namespace + "parametersDiv");
		if (paramDiv) {
			paramDiv.destroy();
		}
	
		var div = dojo.doc.createElement( 'div' );
		div.id = this.namespace + "parametersDiv";
    	dojo.place(  div, dojo.byId (this.namespace + "parametersDivContainer"), "after"  );

		this.paramWidget_=new ibm.tivoli.tip.charts.dijit.ParametersWidget (
			{
				namespace: this.namespace,
				data: data
			}, 
			dojo.byId(this.namespace + "parametersDiv")
		);
		this.paramWidget_.startup();
	
		this.oldParameterFragment_ = this.getParametersAsURLFragment();
	},
	showTableOnly : function () {
	    var tableRadio = dijit.byId(this.namespace + "tableSelected");
	    var chartRadio = dijit.byId(this.namespace + "chartSelected");
	
		tableRadio.setChecked (true);
		tableRadio.setDisabled (true);
		chartRadio.setChecked (false);
		chartRadio.setDisabled (true);
		var showLegend = dijit.byId (this.namespace + "showLegendCB");
		showLegend.setDisabled(true);
		
		var showNameInChart = dijit.byId (this.namespace + "showNameInChart");
		showNameInChart.setDisabled(true);
	
		// Show table
    	this.tableDiv.style.display = "";
		// Hide chart and empty the contents
		dojo.byId (this.id + "chartImageDiv").innerHTML = "";
		this.chartDiv.style.display = "none";
	
		console.log ("showTableOnly. creating table");
		var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");
		chartNavigator.setCurrentPage (chartNavigator.TABLE_PAGE);

		this.createOrUpdateTable(true);
	},
	showChartAndTable: function() {
	    var tableRadio = dijit.byId(this.namespace + "tableSelected");
	    var chartRadio = dijit.byId(this.namespace + "chartSelected");
		var showNameInChart = dijit.byId (this.namespace + "showNameInChart");

		showNameInChart.setDisabled(false);
		tableRadio.setDisabled (false);
		chartRadio.setDisabled (false);
		var showLegend = dijit.byId (this.namespace + "showLegendCB");
		showLegend.setDisabled(false);
	
		// Show toggle button
		var button = dojo.byId (this.namespace + "toggleButton");
		button.style.display = "";
	//	var toolbarDiv = dojo.byId (this.namespace + "toolbarDiv");
	//	toolbarDiv.removeChild (button);
		var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");

		if (chartRadio.checked) {	
			// Hide table
	    	this.tableDiv.style.display = "none";
			// Show chart
			this.chartDiv.style.display = "";
			chartNavigator.setCurrentPage (chartNavigator.CHART_PAGE);
		} else {
			console.log ("showChartAndTable: showTable & hideChart");
			// Show table
		    this.tableDiv.style.display = "";
			// Hide chart
			this.chartDiv.style.display = "none";
			chartNavigator.setCurrentPage (chartNavigator.TABLE_PAGE);
			this.createOrUpdateTable(true);
		}
	},
	makeChartProperties: function () {
		if (this.prefsDialog === null) {
			console.log ("making chart properties");
		    var context = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace);
		
			this.prefsDialog = new ibm.tivoli.tip.charts.dijit.ChartProperties(
				{ 	namespace: this.namespace,
					contextPath: context.contextPath,
					formURL: context.portletActionURL
				},
				dojo.byId (this.namespace + "prefs_dialog")
			);
			this.prefsDialog.startup();
			console.log ("tipserverradio: ");
			console.log (dojo.byId (this.namespace + "tipServer"));
		} else {
			console.log ("chart properties already made");
		}
	},
	getChartInfoCallback: function (data, ioArgs) {
		console.log ("enter getChartInfoCallback with data");
		console.log (data);
		
		var nameField = dojo.byId(this.namespace + "chartName");
		var heightField = dojo.byId(this.namespace + "height");
		var widthField = dojo.byId (this.namespace + "width");
		var showLegendField = dijit.byId (this.namespace + "showLegendCB");
		var descriptionField = dijit.byId(this.namespace + "description");
		var chartRadio = dijit.byId (this.namespace + "chartSelected");
		var tableRadio = dijit.byId (this.namespace + "tableSelected");
		var checkForUpdatesCB = dijit.byId (this.namespace + "checkForUpdatesCB");
		var receiveContextRadio = dijit.byId(this.namespace + "contextualParametersSelected");
		var useDefaultContextRadio = dijit.byId(this.namespace + "defaultParametersSelected");
		var showNameInChart = dijit.byId (this.namespace + "showNameInChart");
		var showLastUpdated = dijit.byId (this.namespace + "showLastUpdated");
		
		nameField.value = data.name;
		dojo.byId(this.namespace + "chartNameH").value = data.name;
		descriptionField.setValue(data.description);
		dojo.byId(this.namespace + "descriptionH").value = data.description;
		heightField.value = data.height;
		widthField.value = data.width;
		if ((data.showLegend === true) || (data.showLegend === "true")) {
			showLegendField.setChecked (true);
		} else {
			showLegendField.setChecked (false);
		}
	
		if ((data.viewType === null) || (data.viewType === "") || (data.viewType === "chart")) {
			chartRadio.setChecked (true);
			tableRadio.setChecked (false);
		} else {
			chartRadio.setChecked (false);
			tableRadio.setChecked (true);
		}
	
		if ((data.autoUpdateActive === true) || (data.autoUpdateActive === "true")) {
			checkForUpdatesCB.setChecked (true);
			
		} else {
			checkForUpdatesCB.setChecked (false);
		}
		
		if ((data.showNameInChart === true) || (data.showNameInChart === "true")) {
			showNameInChart.setChecked (true);
		} else {
			showNameInChart.setChecked (false);
		}
		
		if ((data.showLastUpdated === true) || (data.showLastUpdated === "true")) {
			showLastUpdated.setChecked (true);
		} else {
			showLastUpdated.setChecked (false);
		}

		this.mssName_ = data.mssName;
		if (data.updateMultiplier) {
			this.updateMultiplier = data.updateMultiplier;
    }
    if ( data.updateMinInterval ) {
      this.updateMinInterval = data.updateMinInterval;
    }
    if ( data.updateMaxInterval ) {
      this.updateMaxInterval = data.updateMaxInterval;
    }
  
		
		if ((data.receiveContextActive === true) || (data.receiveContextActive === "true")) {
			receiveContextRadio.setChecked (true);
			useDefaultContextRadio.setChecked  (false);
		} else {
			receiveContextRadio.setChecked (false);
			useDefaultContextRadio.setChecked (true);
		}
		
		this.oldName_ = nameField.value;
		this.oldDescription_ = descriptionField.getValue();
		this.oldHeight_ = heightField.value;
		this.oldWidth_ = widthField.value;
		this.oldShowLegend_ = showLegendField.checked;
		this.oldChartRadio_ = chartRadio.checked;
		this.oldCheckForUpdates_ = checkForUpdatesCB.checked;
		this.oldReceiveContext_ = receiveContextRadio.checked;
		this.oldShowNameInChart_ = showNameInChart.checked;
		this.oldShowLastUpdated_ = showLastUpdated.checked;
		
    	this.createParamWidget (this.reportName);
    	
    	// set the portlet title to the chart name
    	this.tipHelper_.setPortletTitle (this.domNode, data.name);
		this.global.setPortletTitle (this.tipHelper_.getPortletTitle (this.domNode));
    	
    	if (showLastUpdated.checked) {
    		dojo.style (this.metaDiv, "display", "");
    	}
	},
	getChartInfo: function (sourceType, connectionName, groupID, chartID, chartName, persist) {
		var errorHandler = { showMsg : true, callback: dojo.hitch (this, this.onError) };
		var kw = {
        	content:   {
        		command: "getChartInfo",
	        	arg_chartID: encodeURI(chartID),
    	    	arg_portletNamespace: this.namespace,
        		arg_chartSrcType: sourceType,
	        	arg_connectionName: encodeURI(connectionName),
    	    	arg_groupID: encodeURI(groupID),
    	    	arg_persist: persist
                   },
            onExc: errorHandler,
	        onResponse:{
	            callback: dojo.hitch(this, this.getChartInfoCallback)
       	           }
  	     };
  	     
  	     if (chartName !== null) {
  	     	kw.content.arg_chartName = encodeURI(chartName);
  	     }
	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
	},
	serializeParameters: function (params) {
		console.log ("enter serializeParameters with params: ");
		console.log (params);
		var result = "";
		for (var p in params) {
			if (p) {
				result += "&" + p + "=" + params[p];			
			}
		}
	
		return (result);
	},
	getHiddenParameters: function () {
		var urlfrag = this.namespace + "chartNameH=" + dojo.byId (this.namespace + "chartNameH").value;
		urlfrag += "&" + this.namespace + "descriptionH=" + dojo.byId (this.namespace + "descriptionH").value;
		urlfrag += "&" + this.namespace + "connectionNameH=" + dojo.byId (this.namespace + "connectionNameH").value;
		urlfrag += "&" + this.namespace + "groupIDH=" + dojo.byId (this.namespace + "groupIDH").value;
		urlfrag += "&" + this.namespace + "chartIDH=" + dojo.byId (this.namespace + "chartIDH").value;
		var webservice = dojo.byId (this.namespace + "tivoliApp");
		var custom = dojo.byId (this.namespace + "tipServer");
		var type = "";
		if (webservice.checked) {
			type = webservice.value;
		} else if (custom.checked) {
			type = custom.value;
		}
		
		urlfrag += "&" + this.namespace + "chartSourceTypeGroup=" + type;

		return (urlfrag);	
	},
	saveUserPrefs: function () {
		this.savePrimitive ("saveUser", false);
	},
	onSave: function () {
		this.savePrimitive ("saveShared", true);
	},
	savePrimitive: function (action, showCompletion) {
		var callback = null;
		console.log ("enter savePrimitive with args: " + action + ", " + showCompletion);
		if (showCompletion) {
			callback = dojo.hitch (this, this.onSaveComplete);
		} 
		
		if (this.allowSubmit_) {
			var urlFrag = this.getParametersAsURLFragment();
			var form = dojo.byId (this.namespace + "form");
			var propertiesDialogForm = dijit.byId (this.namespace + "propertiesForm");
			var hiddenparams = this.getHiddenParameters();
			var url = "?" + hiddenparams + "&" + urlFrag + this.serializeParameters (propertiesDialogForm.getValues());

			var tbl = dijit.byId (this.namespace + "tbl_tipChartData");
			if (tbl) {
				var tablePrefs = tbl.getPreferences();
				if (tablePrefs !== null) {
					url += "&arg_tablePreferences=" + tablePrefs;
				}
			}
			
			var kw = {
				 appendURL: url,
	             content:   {
                        command: "savePreferences",
                        arg_portletNamespace: this.namespace,
                        action: action
                        },
            	 onResponse:{
                         callback: callback
       	                }
    	     };
	        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		} else {
			this.allowSubmit_ = true;
		}
		
		// do not submit
		return (false);
	},
	onResetPrimitive: function (action, reloadPrefs) {
		var callback = null;
		
		if (reloadPrefs === false) {
			callback = null;
		} else {
			callback = dojo.hitch(this, this.afterReset);
		}
		
		var kw = {
	             content:   {
                        command: "savePreferences",
                        arg_portletNamespace: this.namespace,
                        action: action
                        },
            	 onResponse:{
                         callback: callback
       	                }
    	     };
	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		
		// do not submit
		return (false);
	},
	onReset: function () {
		this.onResetPrimitive ("resetDefaults");
	},
	onResetMyPreferences: function (reloadDefaultPrefs) {
		this.onResetPrimitive ("resetMine", reloadDefaultPrefs);
	},
	afterReset: function () {
		var chartNav = dijit.byId (this.namespace + "mainChartNavigatorDiv");
		chartNav.showChartNavigator();
		this.showChartSelector();
		chartNav.getPortletPreferences();
	},
	onSaveComplete: function (data, ioArgs) {
		console.info ("enter onSaveComplete");

		var msgID = "TIPCH3005I";
		var msg = this.messages_.TIPCH3005I;
		var context = ibm.tivoli.tip.charts.dojo.Global.getSingleton(this.namespace);
		context.showMessageDialog("info", msgID, msg, false);
	},
	showPrefs: function () {
		var prefsDialog = dijit.byId (this.namespace + "prefs_dialog");
		if (prefsDialog) {
			try {
				prefsDialog.show();
			} catch (e) {
				// alert ("caught error: " + e);
				console.error ("caught error in showPrefs: ");
				console.error (e);
				// handle IE error and try to show again.
				prefsDialog.show();
			}
		}
	},
	getSourceMSSName: function () {
		//	e.g., "ibm-cdm:///CDMMSS/Hostname=pico.raleigh.ibm.com,ManufacturerName=IBM,ProductName=IBM Tivoli Monitoring"
		return this.mssName_;
	},
	isInteger: function (value) {
	//    return ((value+'').match(/^(+|-)?\d+$/) != null);
		return (true);
	},
	initCounter: function () {
		this.counter = Math.random();
	},
	handleOnEnter: function () {
		console.log ("enter ChartWidget.handleOnEnter");
		this.allowSubmit_ = false;
	},
	processEvent: function (event) {
		try {
			console.log ("enter processEvent");
			console.log (event);
			var receiveContextRadio = dijit.byId(this.namespace + "contextualParametersSelected");
		
			if (event.name == "http://ibm.com/isclite#portletResize") {
				if (this.shouldResize()) {
					var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");
					var myportletsize = this.getChartSize();
					var newWidth = myportletsize.available.w;
					var newHeight = myportletsize.available.h;

					if (chartNavigator.getCurrentPage() == chartNavigator.CHART_PAGE) {
						this.resizeChart (newWidth, newHeight);
					} else if (chartNavigator.getCurrentPage() == chartNavigator.CONNECTION_MGR_PAGE) {
						chartNavigator.resize (newWidth, newHeight);
					} else if (chartNavigator.getCurrentPage() == chartNavigator.WS_CHART_SELECTOR_PAGE) {
						var wsChartSelector = dijit.byId (chartNavigator.id + "chartSelectorDiv");
						wsChartSelector.resize();
					} else if (chartNavigator.getCurrentPage() == chartNavigator.TABLE_PAGE) {
						this.resizeTable();
					} else {
						console.log ("current page is not resizable... so not invoking resize");
					}
				}
			} else if (event.name == "http://ibm.com/tip#NodeClickedOn") {
				if (receiveContextRadio && receiveContextRadio.checked) {
					var matchingMSSIndex = this.getMatchingMSSIndex (event, this.getSourceMSSName());		
		//			alert ("matchingMSSIndex: " + matchingMSSIndex)
					if (matchingMSSIndex < 0) {
						// no matching MSS found, so call to transform
						event = this.transformEvent (event);
					} else {
						// matching MSS found, so no need to transform, 
						// just invoke post transform processing
						this.onTransformEnd (event);
					}
				} else {
					console.log ("receive context is off");
				}
			} else if (event.name == "http://ibm.com/isclite#launchPortlet") {
				console.log ("handling launchPortlet event");
			    if (event.connectionType && event.chartID) {
					if (event.connectionName) {
					    var reportSelectorDiv = dojo.byId(this.namespace + "reportSelectorDiv");
						reportSelectorDiv.style.display = "none";
				    
						var selector = new ibm.tivoli.tip.charts.dijit.ChartSelectorWidget ({datasource_: event.connectionName, populateGroups: false, namespace_: this.namespace });
						selector.getChartDefinition (event.groupID, event.chartID);
					} else {
						console.log ("handleEvent: run report");
						this.onReportSelection (event.connectionType, null, event.groupID, event.chartID, null, null, true);
					}
				}
			} else {
				console.log ("received unknown event: ");
				console.log (event);
			}
		} catch (e) {
			console.error ("caught exception in processEvent");
			console.error (e);
		}
	},
	shouldResize: function () {
		var portletSize = iscPortlet.getPortletSize(this.iscPortletNamespace);
		var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");

		if (this.lastPortletSize_ &&
		    this.lastPage_ &&
		    (portletSize.available.w == this.lastPortletSize_.available.w) &&
		    (portletSize.available.h == this.lastPortletSize_.available.h) &&
		    (this.lastPage_ == chartNavigator.getCurrentPage())) {
			console.log ("shouldResize. return false.");
			return (false);
		} else {
			this.lastPage_ = chartNavigator.getCurrentPage();
			this.lastPortletSize_ = portletSize;
			console.log ("shouldResize. return true.");
			return (true);
		}
	},
	getMatchingMSSIndex : function (event, srcMssName) {
		console.log ("src MSS: " + srcMssName);
		var index = -1;
		
		if (this.equalsIgnoreCase (event.MSSName, srcMssName)) {
			index = 0;
		} else {
			var i = 1;
			console.log ("entering for loop");
			forloop:
			for (i=1; ; i++) {
				console.log ("in for loop with index: " + i);
				var value = event["MSSName" + i];
				console.log ("event.MSSName" + i + ": " + value);
				if (value) {
					if (this.equalsIgnoreCase (value, srcMssName)) {
						index = i;
						break forloop;
					}
				} else {
					break forloop;
				}
			}
		}
		
		console.log ("returning matching mss index: " + index);
		return (index);
	},
	equalsIgnoreCase: function (str1, str2) {
		if ((str1 === null) && (str2 === null)) {
			return (true);
		} else if ((str1 === null) || (str2 === null)) {
			return (false);
		} else {
			return (str1.toLowerCase() == str2.toLowerCase());
		}
	},
	getMatchingMSSIndexOld : function (event, srcMssName) {
		console.log ("src MSS: " + srcMssName);
		var index = -1;
	
		forloop:
		for (var i=1; ; i++) {
			var value = eval ("event.R" + i + "_mssName");
			console.log ("event.R" + i + "_mssName: " + value);
			if (value) {
				if (value == srcMssName) {
					index = i;
					break forloop;
				}
			} else {
				break forloop;
			}
		}
		
		console.log ("returning matching mss index: " + index);
		return (index);
	},
	
	transformEvent: function (event) {
		console.log ("enter transformEvent with event:");
		console.log (event);
		var transformInfo = {
                              "uniqueName": "com.ibm.tivoli.tip.TIPTransformation",
                              "locationUniqueName": "com.ibm.tivoli.tip.TIPTransformation",
                              "eventObj": event,
                              "srcPortletNamespace": this.iscPortletNamespace,
                              "handler": dojo.hitch (this, this.onTransformEnd)
                            };
        EventBroker.executeTransform(transformInfo);
	},
	onTransformEnd: function (event) {
		console.log ("enter onTransformEnd with event: ");
		console.log (event);
		var matchingMSSIndex = this.getMatchingMSSIndex (event, this.getSourceMSSName());
		if (matchingMSSIndex > 0) {
			console.log("MSSName" + event["MSSName" + matchingMSSIndex]);
			console.log ("SourceToken" + event["SourceToken" + matchingMSSIndex]);

			event.MSSName = event["MSSName" + matchingMSSIndex];
			event.SourceToken = event["SourceToken" + matchingMSSIndex];
			console.log ("event: ");
			console.log (event);
		}

		this.paramWidget_.setAllContext (event);
		// updateProperties will also run a report to regenerate the graph (but only if the properties changed).
		this.updateProperties(false);
	},
	getMenuItems: function () {
		var menuItems = [
			{ id: this.namespace + "RefreshChartMenuItem", label: this.resources_.REFRESH, iconClass: "refreshIcon", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').refreshChart();", enabled: true },
			{ id: this.namespace + "ReloadChartMenuItem", label: this.resources_.RELOAD, iconClass: "refreshIcon", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').reloadChart();", enabled: true },
			{ id: "separator" },
			{ id: this.namespace + "PreferencesMenuItem", label: this.resources_.PREFERENCES, iconClass: "propertiesIcon", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').showPrefs();", enabled: true },
			{ id: this.namespace + "ToggleTableChartMenuItem", label: this.resources_.TOGGLE_TABLE_CHART, iconClass: "toggleIcon", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').toggleTableChart();", enabled: true },
			{ id: this.namespace + "ReturnToChartSelectorMenuItem", label: this.resources_.RETURN_TO_CHART_SELECTOR, iconClass: "backIcon", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').showChartSelector();", enabled: true },
			{ id: "separator" },
			{ id: this.namespace + "ShowHideToolbarMenuItem", label: this.resources_.SHOW_HIDE_TOOLBAR, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').toggleToolbar();", enabled: true },
			{ id: "separator" },
			{ id: this.namespace + "PrintPreviewMenuItem", label: this.resources_.PRINT_PREVIEW, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').printPreviewChart();", enabled: true },
			{ id: this.namespace + "SaveAsFileMenuItem", label: this.resources_.SAVE_AS_FILE, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').saveChartAsFile();", enabled: true },
			{ id: "separator" }
		];
		
		var context = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace);
		if (context.roles.admin || context.roles.creator) {
			menuItems.push ({ id: this.namespace + "SaveForAll", label: this.resources_.SAVE_FOR_OTHERS, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').onSave();", enabled: true });
			menuItems.push ({ id: this.namespace + "ResetForAll", label: this.resources_.CLEAR_DEFAULT_PREFERENCES, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').onReset();", enabled: true });
		}
		
		menuItems.push ({ id: this.namespace + "ResetForMe", label: this.resources_.CLEAR_MY_PREFERENCES, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.namespace + "chartWidget').onResetMyPreferences();", enabled: true });
		
		return (menuItems);
	},
	getSelectedData: function () {
	},
	makeChartContextMenu: function () {
		var provider = new ibm.tivoli.tip.dijit.TIPContextMenuProviderV2(
					{ iscPortletNamespace: this.iscPortletNamespace,
					  getMenuItemsCallback: dojo.hitch (this, this.getMenuItems)
					});
		console.log ("after make provider");

		var chartMenu = new ibm.tivoli.tip.dijit.TIPContextMenuProxyV2(
			{cmProvider: provider, 
			 targetNodeIds: [this.id + "chartImageDiv"],
			 getContextCallback: dojo.hitch (this, this.getSelectedData),
			 id: this.namespace + "chartMenu"
			});
		console.log ("after create context menu");
//		chartMenu.startup();
	},
	resizeChart: function (newWidth, newHeight) {
		console.log ("enter resizeChart with width: " + newWidth + ", and height: " + newHeight);
		this.actualImgHeight_ = newHeight;
		this.actualImgWidth_ = newWidth;
		
		var heightField = dojo.byId(this.namespace + "height");
		var widthField = dojo.byId (this.namespace + "width");
		
		heightField.value = newHeight;
		widthField.value = newWidth;
		
		var context = {};
		context.command = "modifyReport";
		context.arg_portletNamespace = this.namespace;
		context.arg_reportName = encodeURI(this.reportName);
		context.arg_chartSrcType = this.chartSrcType_;
		context.arg_connectionName = encodeURI(this.connectionName_);
		context.arg_groupID = encodeURI(this.groupID_);
		context.arg_dataSource = encodeURI(this.connectionName_);
		context.arg_chartID = encodeURI(this.reportName);
		context.arg_persist = false;
		context.shouldRunReport = "true";
		
		context.arg_height = newHeight;
		context.arg_width = newWidth;

		var kw = {
             content: context,
           	 onResponse:{
                      callback: dojo.hitch (this, this.runReportCallback)
   	         }
   	     };

		this.makeRequestPrimitive (kw);
	},
	makeRequestPrimitive: function (requestContext) {
		console.log ("enter ChartWidget.makeRequestPrimitive with context: ");
		console.log (requestContext);
		
		if (requestContext.content.command == "modifyReport") {
			// check to see if a modifyReport request is already in process.  
			// If so, we need to queue this one or ignore it
			console.log ("ChartWidget.makeRequestPrimitive: queue length: " + this.requestQueue.length);
		    // start the count for run report response time here
		    this.runReportStartTime = new Date().getTime();
			if (this.requestQueue.length > 0) {
				console.log ("ChartWidget.makeRequestPrimitive: adding request to queue for future processing");
				this.requestQueue.push (requestContext);
			} else {
				console.log ("ChartWidget.makeRequestPrimitive: processing request now");
				this.requestQueue.push (requestContext);
				ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( requestContext );
			}
		} else {
			console.log ("ChartWidget.makeRequestPrimitive: not a request we need to queue.");
	        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( requestContext );
	    }
	},
	resizeTable: function () {
		var portletSize = iscPortlet.getPortletSize(this.iscPortletNamespace);
		var size = { w: portletSize.available.w, h: portletSize.available.h };
		dijit.byId (this.namespace + "tbl_tipChartData").resize (size);
	},
	getChartSize: function () {
		var size = iscPortlet.getPortletSize(this.iscPortletNamespace);
		console.log ("got portlet size, available.w: " + size.available.w + ", h: " + size.available.h);
		// temporary hack for IE
		if ((size.available.w === undefined) ||
			isNaN(size.available.w)) {
			// guess
			size.available.w = 450;
		}
		
		var coords = null;
		
		var node = dojo.byId (this.namespace + "toolbarDiv");
		if (node) {
			// subtract size of toolbar 
			coords = dojo.coords (node);
			size.available.h = size.available.h - coords.h;
			console.log ("removing toolbar size: " + coords.h);
		} 
		
		node = dojo.byId (this.id + "nub");
		if (node) {
			// subtract size of toolbar nub
			coords = dojo.coords (node);
			size.available.h = size.available.h - coords.h;
		} else {
			// nub is 8 pixels
			size.available.h = size.available.h - 8;
			console.log ("removing fixed nub size");
		}
		
		node = this.metaDiv;
		var showLastUpdated = dijit.byId (this.namespace + "showLastUpdated");
		if (node && showLastUpdated && showLastUpdated.checked) {
			// subtract size of date 
			coords = dojo.coords (node);
			if (coords.h < 16) {
				coords.h = 16;
			}
			size.available.h = size.available.h - coords.h;
			console.log ("removed meta data size: " + coords.h);
		} else if (this.firstRender) {
			console.log ("firstRender and showLastUpdated is false.");
			// 1st render so those are not available yet, so use fixed size
			size.available.h = size.available.h - 16;
			this.firstRender = false;
		}
		
		// allow for extra space b/c we still get scroll bars on fixed size pages
		if (dojo.isIE) {
			size.available.h = size.available.h - 30;
			size.available.w = size.available.w - 18;
		} else {
			size.available.h = size.available.h - 12;
			size.available.w = size.available.w - 5;
		}
			
		// minimum height
		if (size.available.h <= 25) {
			size.available.h = 25;
		}
		
		console.log ("return chart size (after subtracting other UI elements): ");
		console.log (size);
		
		return (size);
	},
	onError: function (msg, request) {
		console.log ("enter ChartWidget.onError with msg: " + msg);
		console.log ("request was: ");
		console.log (request);
		// Show the chart div so we get the toolbar
		var chartNavigator = dijit.byId (this.namespace + "mainChartNavigatorDiv");
		console.log ("chartNav visible: " + chartNavigator.isNavigatorVisible());
		console.log ("chartDiv visiable: " + this.chartDiv.style.display);
		console.log ("tableDiv visiable: " + this.tableDiv.style.display);
		var cleanup = true;
		
		if (request.content.command == "modifyReport") {
			// pop off the most recent request which was just run
			this.requestQueue.shift();
			this.reportSelectorDiv.style.display = "none";
			this.chartDiv.style.display = "";
			this.openChartToolbar();
			cleanup = false;
		} 
		
		if ((!chartNavigator.isNavigatorVisible()) &&
			(this.chartDiv.style.display == "none") &&
			(this.tableDiv.style.display == "none")) {
			this.chartDiv.style.display = "";
			this.openChartToolbar();
		} 
			
		if (cleanup) {
			// Clean up after error to avoid any div errors on subsequent requests
			this.cleanupForChartChange();
		}
	},
	destroy: function () {
		console.log ("enter ChartWidget.destroy");

		var paramDiv = dijit.byId (this.namespace + "parametersDiv");
		if (paramDiv) {
			paramDiv.destroy();
		}
	
		dojo.forEach (this.connections, function (item) {
			dojo.disconnect (item);
		});
		dojo.forEach (this.topics_, function (topic) {
			dojo.unsubscribe (topic);
		});
		// remove tooltips
		dojo.forEach (this.tooltips, function (tt) {
			tt.destroy();
		});
		
		if (this.toggleSubscription) {
			dojo.unsubscribe (this.toggleSubscription);
			this.toggleSubscription = null;
		}
		
		// remove auto-refresh
		if (this.interval !== null) {
			clearTimeout (this.interval);
			delete this.interval;
		}

//		this.destroyDescendants();
		this.inherited ("destroy", arguments);

		console.log ("exit ChartWidget.destroy");
	}
});
